/* engine.c generated by valac 0.56.17, the Vala compiler
 * generated from engine.vala, do not modify */

/* 
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <ibus.h>
#include <glib-object.h>
#include <libkkc/libkkc.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <libutil.h>
#include <config.h>
#include <stdio.h>
#include <gio/gio.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_KKC_ENGINE (kkc_engine_get_type ())
#define KKC_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KKC_ENGINE, KkcEngine))
#define KKC_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KKC_ENGINE, KkcEngineClass))
#define IS_KKC_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KKC_ENGINE))
#define IS_KKC_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KKC_ENGINE))
#define KKC_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KKC_ENGINE, KkcEngineClass))

typedef struct _KkcEngine KkcEngine;
typedef struct _KkcEngineClass KkcEngineClass;
typedef struct _KkcEnginePrivate KkcEnginePrivate;
enum  {
	KKC_ENGINE_0_PROPERTY,
	KKC_ENGINE_NUM_PROPERTIES
};
static GParamSpec* kkc_engine_properties[KKC_ENGINE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KkcEngine {
	IBusEngine parent_instance;
	KkcEnginePrivate * priv;
};

struct _KkcEngineClass {
	IBusEngineClass parent_class;
};

struct _KkcEnginePrivate {
	KkcContext* context;
	IBusLookupTable* lookup_table;
	gboolean lookup_table_visible;
	gboolean use_custom_keymap;
	gboolean show_annotation;
	IBusKeymap* keymap;
	IBusProperty* input_mode_prop;
	IBusPropList* prop_list;
	gboolean properties_registered;
	GeeMap* input_mode_props;
	GeeMap* input_mode_symbols;
	GeeMap* name_input_modes;
	GtkClipboard* clipboard;
	guint save_dictionaries_timeout_id;
};

static gint KkcEngine_private_offset;
static gpointer kkc_engine_parent_class = NULL;
static gboolean kkc_engine_ibus;
static Preferences* kkc_engine_preferences;
static Preferences* kkc_engine_preferences = NULL;
static GeeArrayList* kkc_engine_dictionaries;
static GeeArrayList* kkc_engine_dictionaries = NULL;
static KkcLanguageModel* kkc_engine_language_model;
static KkcLanguageModel* kkc_engine_language_model = NULL;
static gboolean kkc_engine_ibus = FALSE;

VALA_EXTERN GType kkc_engine_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KkcEngine, g_object_unref)
static void kkc_engine_set_selection_text (GtkClipboard* clipboard,
                                    const gchar* text,
                                    KkcEngine* self);
static void kkc_engine_populate_lookup_table (KkcEngine* self);
static void kkc_engine_set_lookup_table_cursor_pos (KkcEngine* self);
static void kkc_engine_update_preedit (KkcEngine* self);
static void kkc_engine_update_candidates (KkcEngine* self);
static void kkc_engine_update_input_mode (KkcEngine* self);
static void kkc_engine_reload_dictionaries (void);
static void kkc_engine_apply_preferences (KkcEngine* self);
static IBusProperty* kkc_engine_register_input_mode_property (KkcEngine* self,
                                                       KkcInputMode mode,
                                                       const gchar* name,
                                                       const gchar* label,
                                                       const gchar* symbol);
static gboolean kkc_engine_process_lookup_table_key_event (KkcEngine* self,
                                                    guint keyval,
                                                    guint keycode,
                                                    guint state);
static gboolean _vala_string_array_contains (const gchar* * stack,
                                      gssize stack_length,
                                      const const gchar* needle);
static gboolean kkc_engine_real_process_key_event (IBusEngine* base,
                                            guint keyval,
                                            guint keycode,
                                            guint state);
static void kkc_engine_real_enable (IBusEngine* base);
static gboolean __lambda4_ (KkcEngine* self);
static gboolean ___lambda4__gsource_func (gpointer self);
static void kkc_engine_real_disable (IBusEngine* base);
static void kkc_engine_real_reset (IBusEngine* base);
static void kkc_engine_real_focus_in (IBusEngine* base);
static void kkc_engine_real_focus_out (IBusEngine* base);
static void kkc_engine_real_property_activate (IBusEngine* base,
                                        const gchar* prop_name,
                                        guint prop_state);
static void kkc_engine_real_candidate_clicked (IBusEngine* base,
                                        guint index,
                                        guint button,
                                        guint state);
static void kkc_engine_real_cursor_up (IBusEngine* base);
static void kkc_engine_real_cursor_down (IBusEngine* base);
static void kkc_engine_real_page_up (IBusEngine* base);
static void kkc_engine_real_page_down (IBusEngine* base);
static void kkc_engine_real_set_content_type (IBusEngine* base,
                                       guint purpose,
                                       guint hints);
static gint kkc_engine_main (gchar** args,
                      gint args_length1);
static void __lambda5_ (void);
static void ___lambda5__ibus_bus_disconnected (IBusBus* _sender,
                                        gpointer self);
static void __lambda6_ (const gchar* name,
                 GVariant* value);
static void ___lambda6__preferences_value_changed (Preferences* _sender,
                                            const gchar* name,
                                            GVariant* value,
                                            gpointer self);
VALA_EXTERN KkcEngine* kkc_engine_new (void);
VALA_EXTERN KkcEngine* kkc_engine_construct (GType object_type);
static GObject * kkc_engine_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void _kkc_engine___lambda7_ (KkcEngine* self,
                             const gchar* name,
                             GVariant* value);
static void __kkc_engine___lambda7__preferences_value_changed (Preferences* _sender,
                                                        const gchar* name,
                                                        GVariant* value,
                                                        gpointer self);
static void _kkc_engine___lambda8_ (KkcEngine* self);
static void __kkc_engine___lambda8__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self);
static void _kkc_engine___lambda9_ (KkcEngine* self,
                             GObject* s,
                             GParamSpec* p);
static void __kkc_engine___lambda9__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self);
static void _kkc_engine___lambda10_ (KkcEngine* self);
static void __kkc_engine___lambda10__kkc_candidate_list_populated (KkcCandidateList* _sender,
                                                            gpointer self);
static void _kkc_engine___lambda11_ (KkcEngine* self);
static void __kkc_engine___lambda11__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self);
static void _kkc_engine___lambda12_ (KkcEngine* self);
static void __kkc_engine___lambda12__kkc_candidate_list_selected (KkcCandidateList* _sender,
                                                           KkcCandidate* candidate,
                                                           gpointer self);
static void _kkc_engine___lambda13_ (KkcEngine* self,
                              KkcContext* e);
static void __kkc_engine___lambda13__kkc_context_request_selection_text (KkcContext* _sender,
                                                                  gpointer self);
static void kkc_engine_finalize (GObject * obj);
static GType kkc_engine_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gchar* KKC_ENGINE_LOOKUP_TABLE_LABELS[16] = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "a", "b", "c", "d", "e", "f"};
static const GOptionEntry KKC_ENGINE_options[2] = {{"ibus", 'i', (gint) 0, G_OPTION_ARG_NONE, &kkc_engine_ibus, N_ ("Component is executed by IBus"), NULL}, {NULL}};

static inline gpointer
kkc_engine_get_instance_private (KkcEngine* self)
{
	return G_STRUCT_MEMBER_P (self, KkcEngine_private_offset);
}

static void
kkc_engine_set_selection_text (GtkClipboard* clipboard,
                               const gchar* text,
                               KkcEngine* self)
{
	KkcContext* _tmp0_;
#line 181 "engine.vala"
	g_return_if_fail (self != NULL);
#line 181 "engine.vala"
	g_return_if_fail (clipboard != NULL);
#line 182 "engine.vala"
	_tmp0_ = self->priv->context;
#line 182 "engine.vala"
	kkc_context_set_selection_text (_tmp0_, text);
#line 250 "engine.c"
}

static void
kkc_engine_populate_lookup_table (KkcEngine* self)
{
	IBusLookupTable* _tmp0_;
#line 185 "engine.vala"
	g_return_if_fail (self != NULL);
#line 186 "engine.vala"
	_tmp0_ = self->priv->lookup_table;
#line 186 "engine.vala"
	ibus_lookup_table_clear (_tmp0_);
#line 263 "engine.c"
	{
		gint i = 0;
		KkcContext* _tmp1_;
		KkcCandidateList* _tmp2_;
		KkcCandidateList* _tmp3_;
		guint _tmp4_;
		guint _tmp5_;
#line 187 "engine.vala"
		_tmp1_ = self->priv->context;
#line 187 "engine.vala"
		_tmp2_ = kkc_context_get_candidates (_tmp1_);
#line 187 "engine.vala"
		_tmp3_ = _tmp2_;
#line 187 "engine.vala"
		_tmp4_ = kkc_candidate_list_get_page_start (_tmp3_);
#line 187 "engine.vala"
		_tmp5_ = _tmp4_;
#line 187 "engine.vala"
		i = (gint) _tmp5_;
#line 283 "engine.c"
		{
			gboolean _tmp6_ = FALSE;
#line 187 "engine.vala"
			_tmp6_ = TRUE;
#line 187 "engine.vala"
			while (TRUE) {
#line 290 "engine.c"
				KkcContext* _tmp8_;
				KkcCandidateList* _tmp9_;
				KkcCandidateList* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				IBusText* text = NULL;
				KkcContext* _tmp13_;
				KkcCandidateList* _tmp14_;
				KkcCandidateList* _tmp15_;
				KkcCandidate* _tmp16_;
				KkcCandidate* _tmp17_;
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				IBusText* _tmp20_;
				IBusText* _tmp21_;
				IBusLookupTable* _tmp22_;
				IBusText* _tmp23_;
#line 187 "engine.vala"
				if (!_tmp6_) {
#line 310 "engine.c"
					gint _tmp7_;
#line 189 "engine.vala"
					_tmp7_ = i;
#line 189 "engine.vala"
					i = _tmp7_ + 1;
#line 316 "engine.c"
				}
#line 187 "engine.vala"
				_tmp6_ = FALSE;
#line 188 "engine.vala"
				_tmp8_ = self->priv->context;
#line 188 "engine.vala"
				_tmp9_ = kkc_context_get_candidates (_tmp8_);
#line 188 "engine.vala"
				_tmp10_ = _tmp9_;
#line 188 "engine.vala"
				_tmp11_ = kkc_candidate_list_get_size (_tmp10_);
#line 188 "engine.vala"
				_tmp12_ = _tmp11_;
#line 188 "engine.vala"
				if (!(i < _tmp12_)) {
#line 188 "engine.vala"
					break;
#line 334 "engine.c"
				}
#line 190 "engine.vala"
				_tmp13_ = self->priv->context;
#line 190 "engine.vala"
				_tmp14_ = kkc_context_get_candidates (_tmp13_);
#line 190 "engine.vala"
				_tmp15_ = _tmp14_;
#line 190 "engine.vala"
				_tmp16_ = kkc_candidate_list_get (_tmp15_, i);
#line 190 "engine.vala"
				_tmp17_ = _tmp16_;
#line 190 "engine.vala"
				_tmp18_ = kkc_candidate_get_output (_tmp17_);
#line 190 "engine.vala"
				_tmp19_ = _tmp18_;
#line 190 "engine.vala"
				_tmp20_ = ibus_text_new_from_string (_tmp19_);
#line 190 "engine.vala"
				g_object_ref_sink (_tmp20_);
#line 190 "engine.vala"
				_tmp21_ = _tmp20_;
#line 190 "engine.vala"
				_g_object_unref0 (_tmp17_);
#line 190 "engine.vala"
				text = _tmp21_;
#line 192 "engine.vala"
				_tmp22_ = self->priv->lookup_table;
#line 192 "engine.vala"
				_tmp23_ = text;
#line 192 "engine.vala"
				ibus_lookup_table_append_candidate (_tmp22_, _tmp23_);
#line 187 "engine.vala"
				_g_object_unref0 (text);
#line 368 "engine.c"
			}
		}
	}
}

static void
kkc_engine_set_lookup_table_cursor_pos (KkcEngine* self)
{
	IBusText* empty_text = NULL;
	IBusText* _tmp0_;
	gint cursor_pos = 0;
	KkcContext* _tmp1_;
	KkcCandidateList* _tmp2_;
	KkcCandidateList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	KkcContext* _tmp6_;
	KkcCandidateList* _tmp7_;
	KkcCandidateList* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 196 "engine.vala"
	g_return_if_fail (self != NULL);
#line 197 "engine.vala"
	_tmp0_ = ibus_text_new_from_static_string ("");
#line 197 "engine.vala"
	g_object_ref_sink (_tmp0_);
#line 197 "engine.vala"
	empty_text = _tmp0_;
#line 198 "engine.vala"
	_tmp1_ = self->priv->context;
#line 198 "engine.vala"
	_tmp2_ = kkc_context_get_candidates (_tmp1_);
#line 198 "engine.vala"
	_tmp3_ = _tmp2_;
#line 198 "engine.vala"
	_tmp4_ = kkc_candidate_list_get_cursor_pos (_tmp3_);
#line 198 "engine.vala"
	_tmp5_ = _tmp4_;
#line 198 "engine.vala"
	cursor_pos = _tmp5_;
#line 199 "engine.vala"
	_tmp6_ = self->priv->context;
#line 199 "engine.vala"
	_tmp7_ = kkc_context_get_candidates (_tmp6_);
#line 199 "engine.vala"
	_tmp8_ = _tmp7_;
#line 199 "engine.vala"
	_tmp9_ = kkc_candidate_list_get_page_visible (_tmp8_);
#line 199 "engine.vala"
	_tmp10_ = _tmp9_;
#line 199 "engine.vala"
	if (_tmp10_) {
#line 422 "engine.c"
		IBusLookupTable* _tmp11_;
		KkcContext* _tmp12_;
		KkcCandidateList* _tmp13_;
		KkcCandidateList* _tmp14_;
		guint _tmp15_;
		guint _tmp16_;
		IBusLookupTable* _tmp17_;
		KkcCandidate* candidate = NULL;
		KkcContext* _tmp18_;
		KkcCandidateList* _tmp19_;
		KkcCandidateList* _tmp20_;
		KkcCandidate* _tmp21_;
		gboolean _tmp22_ = FALSE;
		gboolean _tmp23_ = FALSE;
#line 200 "engine.vala"
		_tmp11_ = self->priv->lookup_table;
#line 200 "engine.vala"
		_tmp12_ = self->priv->context;
#line 200 "engine.vala"
		_tmp13_ = kkc_context_get_candidates (_tmp12_);
#line 200 "engine.vala"
		_tmp14_ = _tmp13_;
#line 200 "engine.vala"
		_tmp15_ = kkc_candidate_list_get_page_start (_tmp14_);
#line 200 "engine.vala"
		_tmp16_ = _tmp15_;
#line 200 "engine.vala"
		ibus_lookup_table_set_cursor_pos (_tmp11_, cursor_pos - _tmp16_);
#line 202 "engine.vala"
		_tmp17_ = self->priv->lookup_table;
#line 202 "engine.vala"
		ibus_engine_update_lookup_table_fast ((IBusEngine*) self, _tmp17_, TRUE);
#line 203 "engine.vala"
		_tmp18_ = self->priv->context;
#line 203 "engine.vala"
		_tmp19_ = kkc_context_get_candidates (_tmp18_);
#line 203 "engine.vala"
		_tmp20_ = _tmp19_;
#line 203 "engine.vala"
		_tmp21_ = kkc_candidate_list_get (_tmp20_, -1);
#line 203 "engine.vala"
		candidate = _tmp21_;
#line 204 "engine.vala"
		if (self->priv->show_annotation) {
#line 467 "engine.c"
			KkcCandidate* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
#line 205 "engine.vala"
			_tmp24_ = candidate;
#line 205 "engine.vala"
			_tmp25_ = kkc_candidate_get_annotation (_tmp24_);
#line 205 "engine.vala"
			_tmp26_ = _tmp25_;
#line 205 "engine.vala"
			_tmp23_ = _tmp26_ != NULL;
#line 479 "engine.c"
		} else {
#line 204 "engine.vala"
			_tmp23_ = FALSE;
#line 483 "engine.c"
		}
#line 204 "engine.vala"
		if (_tmp23_) {
#line 487 "engine.c"
			KkcCandidate* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
#line 208 "engine.vala"
			_tmp27_ = candidate;
#line 208 "engine.vala"
			_tmp28_ = kkc_candidate_get_annotation (_tmp27_);
#line 208 "engine.vala"
			_tmp29_ = _tmp28_;
#line 208 "engine.vala"
			_tmp22_ = g_strcmp0 (_tmp29_, "?") != 0;
#line 499 "engine.c"
		} else {
#line 204 "engine.vala"
			_tmp22_ = FALSE;
#line 503 "engine.c"
		}
#line 204 "engine.vala"
		if (_tmp22_) {
#line 507 "engine.c"
			IBusText* text = NULL;
			KkcCandidate* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			IBusText* _tmp33_;
			IBusText* _tmp34_;
#line 209 "engine.vala"
			_tmp30_ = candidate;
#line 209 "engine.vala"
			_tmp31_ = kkc_candidate_get_annotation (_tmp30_);
#line 209 "engine.vala"
			_tmp32_ = _tmp31_;
#line 209 "engine.vala"
			_tmp33_ = ibus_text_new_from_string (_tmp32_);
#line 209 "engine.vala"
			g_object_ref_sink (_tmp33_);
#line 209 "engine.vala"
			text = _tmp33_;
#line 211 "engine.vala"
			_tmp34_ = text;
#line 211 "engine.vala"
			ibus_engine_update_auxiliary_text ((IBusEngine*) self, _tmp34_, TRUE);
#line 204 "engine.vala"
			_g_object_unref0 (text);
#line 532 "engine.c"
		} else {
			IBusText* _tmp35_;
#line 213 "engine.vala"
			_tmp35_ = empty_text;
#line 213 "engine.vala"
			ibus_engine_update_auxiliary_text ((IBusEngine*) self, _tmp35_, FALSE);
#line 539 "engine.c"
		}
#line 215 "engine.vala"
		self->priv->lookup_table_visible = TRUE;
#line 199 "engine.vala"
		_g_object_unref0 (candidate);
#line 545 "engine.c"
	} else {
#line 216 "engine.vala"
		if (self->priv->lookup_table_visible) {
#line 217 "engine.vala"
			ibus_engine_hide_lookup_table ((IBusEngine*) self);
#line 218 "engine.vala"
			ibus_engine_hide_auxiliary_text ((IBusEngine*) self);
#line 219 "engine.vala"
			self->priv->lookup_table_visible = FALSE;
#line 555 "engine.c"
		}
	}
#line 196 "engine.vala"
	_g_object_unref0 (empty_text);
#line 560 "engine.c"
}

static void
kkc_engine_update_preedit (KkcEngine* self)
{
	IBusText* text = NULL;
	guint cursor_pos = 0U;
	KkcContext* _tmp0_;
	KkcSegmentList* _tmp1_;
	KkcSegmentList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	IBusText* _tmp75_;
	KkcContext* _tmp78_;
	IBusText* _tmp84_;
	IBusText* _tmp85_;
#line 223 "engine.vala"
	g_return_if_fail (self != NULL);
#line 226 "engine.vala"
	_tmp0_ = self->priv->context;
#line 226 "engine.vala"
	_tmp1_ = kkc_context_get_segments (_tmp0_);
#line 226 "engine.vala"
	_tmp2_ = _tmp1_;
#line 226 "engine.vala"
	_tmp3_ = kkc_segment_list_get_cursor_pos (_tmp2_);
#line 226 "engine.vala"
	_tmp4_ = _tmp3_;
#line 226 "engine.vala"
	if (_tmp4_ >= 0) {
#line 591 "engine.c"
		KkcContext* _tmp5_;
		KkcSegmentList* _tmp6_;
		KkcSegmentList* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		IBusText* _tmp10_;
		gint index = 0;
		gint offset = 0;
		IBusText* _tmp25_;
		KkcContext* _tmp26_;
		KkcSegmentList* _tmp27_;
		KkcSegmentList* _tmp28_;
		KkcSegment* _tmp29_;
		KkcSegment* _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		IBusText* _tmp33_;
		KkcContext* _tmp34_;
		KkcSegmentList* _tmp35_;
		KkcSegmentList* _tmp36_;
		KkcSegment* _tmp37_;
		KkcSegment* _tmp38_;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
#line 227 "engine.vala"
		_tmp5_ = self->priv->context;
#line 227 "engine.vala"
		_tmp6_ = kkc_context_get_segments (_tmp5_);
#line 227 "engine.vala"
		_tmp7_ = _tmp6_;
#line 227 "engine.vala"
		_tmp8_ = kkc_segment_list_get_output (_tmp7_);
#line 227 "engine.vala"
		_tmp9_ = _tmp8_;
#line 227 "engine.vala"
		_tmp10_ = ibus_text_new_from_string (_tmp9_);
#line 227 "engine.vala"
		g_object_ref_sink (_tmp10_);
#line 227 "engine.vala"
		_g_object_unref0 (text);
#line 227 "engine.vala"
		text = _tmp10_;
#line 227 "engine.vala"
		_g_free0 (_tmp9_);
#line 228 "engine.vala"
		index = 0;
#line 229 "engine.vala"
		offset = 0;
#line 640 "engine.c"
		{
			gboolean _tmp11_ = FALSE;
#line 230 "engine.vala"
			_tmp11_ = TRUE;
#line 230 "engine.vala"
			while (TRUE) {
#line 647 "engine.c"
				KkcContext* _tmp13_;
				KkcSegmentList* _tmp14_;
				KkcSegmentList* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				KkcContext* _tmp18_;
				KkcSegmentList* _tmp19_;
				KkcSegmentList* _tmp20_;
				KkcSegment* _tmp21_;
				KkcSegment* _tmp22_;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
#line 230 "engine.vala"
				if (!_tmp11_) {
#line 662 "engine.c"
					gint _tmp12_;
#line 230 "engine.vala"
					_tmp12_ = index;
#line 230 "engine.vala"
					index = _tmp12_ + 1;
#line 668 "engine.c"
				}
#line 230 "engine.vala"
				_tmp11_ = FALSE;
#line 230 "engine.vala"
				_tmp13_ = self->priv->context;
#line 230 "engine.vala"
				_tmp14_ = kkc_context_get_segments (_tmp13_);
#line 230 "engine.vala"
				_tmp15_ = _tmp14_;
#line 230 "engine.vala"
				_tmp16_ = kkc_segment_list_get_cursor_pos (_tmp15_);
#line 230 "engine.vala"
				_tmp17_ = _tmp16_;
#line 230 "engine.vala"
				if (!(index < _tmp17_)) {
#line 230 "engine.vala"
					break;
#line 686 "engine.c"
				}
#line 231 "engine.vala"
				_tmp18_ = self->priv->context;
#line 231 "engine.vala"
				_tmp19_ = kkc_context_get_segments (_tmp18_);
#line 231 "engine.vala"
				_tmp20_ = _tmp19_;
#line 231 "engine.vala"
				_tmp21_ = kkc_segment_list_get (_tmp20_, index);
#line 231 "engine.vala"
				_tmp22_ = _tmp21_;
#line 231 "engine.vala"
				_tmp23_ = kkc_segment_get_output (_tmp22_);
#line 231 "engine.vala"
				_tmp24_ = _tmp23_;
#line 231 "engine.vala"
				offset += g_utf8_strlen (_tmp24_, (gssize) -1);
#line 231 "engine.vala"
				_g_object_unref0 (_tmp22_);
#line 706 "engine.c"
			}
		}
#line 233 "engine.vala"
		_tmp25_ = text;
#line 233 "engine.vala"
		_tmp26_ = self->priv->context;
#line 233 "engine.vala"
		_tmp27_ = kkc_context_get_segments (_tmp26_);
#line 233 "engine.vala"
		_tmp28_ = _tmp27_;
#line 233 "engine.vala"
		_tmp29_ = kkc_segment_list_get (_tmp28_, index);
#line 233 "engine.vala"
		_tmp30_ = _tmp29_;
#line 233 "engine.vala"
		_tmp31_ = kkc_segment_get_output (_tmp30_);
#line 233 "engine.vala"
		_tmp32_ = _tmp31_;
#line 233 "engine.vala"
		ibus_text_append_attribute (_tmp25_, (guint) IBUS_ATTR_TYPE_BACKGROUND, (guint) 0x00c8c8f0, (guint) offset, offset + g_utf8_strlen (_tmp32_, (gssize) -1));
#line 233 "engine.vala"
		_g_object_unref0 (_tmp30_);
#line 238 "engine.vala"
		_tmp33_ = text;
#line 238 "engine.vala"
		_tmp34_ = self->priv->context;
#line 238 "engine.vala"
		_tmp35_ = kkc_context_get_segments (_tmp34_);
#line 238 "engine.vala"
		_tmp36_ = _tmp35_;
#line 238 "engine.vala"
		_tmp37_ = kkc_segment_list_get (_tmp36_, index);
#line 238 "engine.vala"
		_tmp38_ = _tmp37_;
#line 238 "engine.vala"
		_tmp39_ = kkc_segment_get_output (_tmp38_);
#line 238 "engine.vala"
		_tmp40_ = _tmp39_;
#line 238 "engine.vala"
		ibus_text_append_attribute (_tmp33_, (guint) IBUS_ATTR_TYPE_FOREGROUND, (guint) 0x00000000, (guint) offset, offset + g_utf8_strlen (_tmp40_, (gssize) -1));
#line 238 "engine.vala"
		_g_object_unref0 (_tmp38_);
#line 243 "engine.vala"
		cursor_pos = (guint) offset;
#line 751 "engine.c"
	} else {
		KkcContext* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		IBusText* _tmp45_;
		gboolean _tmp46_ = FALSE;
		IBusText* _tmp47_;
#line 245 "engine.vala"
		_tmp41_ = self->priv->context;
#line 245 "engine.vala"
		_tmp42_ = kkc_context_get_input (_tmp41_);
#line 245 "engine.vala"
		_tmp43_ = _tmp42_;
#line 245 "engine.vala"
		_tmp44_ = _tmp43_;
#line 245 "engine.vala"
		_tmp45_ = ibus_text_new_from_string (_tmp44_);
#line 245 "engine.vala"
		g_object_ref_sink (_tmp45_);
#line 245 "engine.vala"
		_g_object_unref0 (text);
#line 245 "engine.vala"
		text = _tmp45_;
#line 245 "engine.vala"
		_g_free0 (_tmp44_);
#line 246 "engine.vala"
		_tmp47_ = text;
#line 246 "engine.vala"
		if (ibus_text_get_length (_tmp47_) > ((guint) 0)) {
#line 782 "engine.c"
			KkcContext* _tmp48_;
			gint _tmp49_;
			gint _tmp50_;
#line 247 "engine.vala"
			_tmp48_ = self->priv->context;
#line 247 "engine.vala"
			_tmp49_ = kkc_context_get_input_cursor_pos (_tmp48_);
#line 247 "engine.vala"
			_tmp50_ = _tmp49_;
#line 247 "engine.vala"
			_tmp46_ = _tmp50_ >= 0;
#line 794 "engine.c"
		} else {
#line 246 "engine.vala"
			_tmp46_ = FALSE;
#line 798 "engine.c"
		}
#line 246 "engine.vala"
		if (_tmp46_) {
#line 802 "engine.c"
			IBusText* _tmp51_;
			KkcContext* _tmp52_;
			gint _tmp53_;
			gint _tmp54_;
			KkcContext* _tmp55_;
			gint _tmp56_;
			gint _tmp57_;
			KkcContext* _tmp58_;
			guint _tmp59_;
			guint _tmp60_;
			IBusText* _tmp61_;
			KkcContext* _tmp62_;
			gint _tmp63_;
			gint _tmp64_;
			KkcContext* _tmp65_;
			gint _tmp66_;
			gint _tmp67_;
			KkcContext* _tmp68_;
			guint _tmp69_;
			guint _tmp70_;
			KkcContext* _tmp71_;
			gint _tmp72_;
			gint _tmp73_;
#line 248 "engine.vala"
			_tmp51_ = text;
#line 248 "engine.vala"
			_tmp52_ = self->priv->context;
#line 248 "engine.vala"
			_tmp53_ = kkc_context_get_input_cursor_pos (_tmp52_);
#line 248 "engine.vala"
			_tmp54_ = _tmp53_;
#line 248 "engine.vala"
			_tmp55_ = self->priv->context;
#line 248 "engine.vala"
			_tmp56_ = kkc_context_get_input_cursor_pos (_tmp55_);
#line 248 "engine.vala"
			_tmp57_ = _tmp56_;
#line 248 "engine.vala"
			_tmp58_ = self->priv->context;
#line 248 "engine.vala"
			_tmp59_ = kkc_context_get_input_cursor_width (_tmp58_);
#line 248 "engine.vala"
			_tmp60_ = _tmp59_;
#line 248 "engine.vala"
			ibus_text_append_attribute (_tmp51_, (guint) IBUS_ATTR_TYPE_BACKGROUND, (guint) 0x00000000, (guint) _tmp54_, _tmp57_ + ((gint) _tmp60_));
#line 253 "engine.vala"
			_tmp61_ = text;
#line 253 "engine.vala"
			_tmp62_ = self->priv->context;
#line 253 "engine.vala"
			_tmp63_ = kkc_context_get_input_cursor_pos (_tmp62_);
#line 253 "engine.vala"
			_tmp64_ = _tmp63_;
#line 253 "engine.vala"
			_tmp65_ = self->priv->context;
#line 253 "engine.vala"
			_tmp66_ = kkc_context_get_input_cursor_pos (_tmp65_);
#line 253 "engine.vala"
			_tmp67_ = _tmp66_;
#line 253 "engine.vala"
			_tmp68_ = self->priv->context;
#line 253 "engine.vala"
			_tmp69_ = kkc_context_get_input_cursor_width (_tmp68_);
#line 253 "engine.vala"
			_tmp70_ = _tmp69_;
#line 253 "engine.vala"
			ibus_text_append_attribute (_tmp61_, (guint) IBUS_ATTR_TYPE_FOREGROUND, (guint) 0xffffffffLL, (guint) _tmp64_, _tmp67_ + ((gint) _tmp70_));
#line 258 "engine.vala"
			_tmp71_ = self->priv->context;
#line 258 "engine.vala"
			_tmp72_ = kkc_context_get_input_cursor_pos (_tmp71_);
#line 258 "engine.vala"
			_tmp73_ = _tmp72_;
#line 258 "engine.vala"
			cursor_pos = (guint) _tmp73_;
#line 878 "engine.c"
		} else {
			IBusText* _tmp74_;
#line 260 "engine.vala"
			_tmp74_ = text;
#line 260 "engine.vala"
			cursor_pos = ibus_text_get_length (_tmp74_);
#line 885 "engine.c"
		}
	}
#line 262 "engine.vala"
	_tmp75_ = text;
#line 262 "engine.vala"
	if (ibus_text_get_length (_tmp75_) > ((guint) 0)) {
#line 892 "engine.c"
		IBusText* _tmp76_;
		IBusText* _tmp77_;
#line 263 "engine.vala"
		_tmp76_ = text;
#line 263 "engine.vala"
		_tmp77_ = text;
#line 263 "engine.vala"
		ibus_text_append_attribute (_tmp76_, (guint) IBUS_ATTR_TYPE_UNDERLINE, (guint) IBUS_ATTR_UNDERLINE_SINGLE, (guint) 0, (gint) ibus_text_get_length (_tmp77_));
#line 901 "engine.c"
	}
#line 270 "engine.vala"
	_tmp78_ = self->priv->context;
#line 270 "engine.vala"
	if (kkc_context_has_output (_tmp78_)) {
#line 907 "engine.c"
		gchar* output = NULL;
		KkcContext* _tmp79_;
		gchar* _tmp80_;
		IBusText* ctext = NULL;
		const gchar* _tmp81_;
		IBusText* _tmp82_;
		IBusText* _tmp83_;
#line 271 "engine.vala"
		_tmp79_ = self->priv->context;
#line 271 "engine.vala"
		_tmp80_ = kkc_context_poll_output (_tmp79_);
#line 271 "engine.vala"
		output = _tmp80_;
#line 272 "engine.vala"
		_tmp81_ = output;
#line 272 "engine.vala"
		_tmp82_ = ibus_text_new_from_string (_tmp81_);
#line 272 "engine.vala"
		g_object_ref_sink (_tmp82_);
#line 272 "engine.vala"
		ctext = _tmp82_;
#line 273 "engine.vala"
		_tmp83_ = ctext;
#line 273 "engine.vala"
		ibus_engine_commit_text ((IBusEngine*) self, _tmp83_);
#line 270 "engine.vala"
		_g_object_unref0 (ctext);
#line 270 "engine.vala"
		_g_free0 (output);
#line 937 "engine.c"
	}
#line 276 "engine.vala"
	_tmp84_ = text;
#line 276 "engine.vala"
	_tmp85_ = text;
#line 276 "engine.vala"
	ibus_engine_update_preedit_text ((IBusEngine*) self, _tmp84_, cursor_pos, ibus_text_get_length (_tmp85_) > ((guint) 0));
#line 223 "engine.vala"
	_g_object_unref0 (text);
#line 947 "engine.c"
}

static void
kkc_engine_update_candidates (KkcEngine* self)
{
#line 281 "engine.vala"
	g_return_if_fail (self != NULL);
#line 282 "engine.vala"
	kkc_engine_populate_lookup_table (self);
#line 283 "engine.vala"
	kkc_engine_set_lookup_table_cursor_pos (self);
#line 959 "engine.c"
}

static void
kkc_engine_update_input_mode (KkcEngine* self)
{
	gboolean changed = FALSE;
	GeeMapIterator* iter = NULL;
	GeeMap* _tmp0_;
	GeeMapIterator* _tmp1_;
	IBusText* symbol = NULL;
	GeeMap* _tmp16_;
	KkcContext* _tmp17_;
	KkcInputMode _tmp18_;
	KkcInputMode _tmp19_;
	gpointer _tmp20_;
	gchar* _tmp21_;
	IBusText* _tmp22_;
	IBusText* _tmp23_;
	IBusText* label = NULL;
	IBusText* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	IBusText* _tmp28_;
	IBusText* _tmp29_;
	IBusProperty* _tmp30_;
	IBusText* _tmp31_;
	IBusText* _tmp32_;
	IBusProperty* _tmp35_;
	IBusText* _tmp36_;
	IBusText* _tmp37_;
	gboolean _tmp40_ = FALSE;
#line 286 "engine.vala"
	g_return_if_fail (self != NULL);
#line 290 "engine.vala"
	_tmp0_ = self->priv->input_mode_props;
#line 290 "engine.vala"
	_tmp1_ = gee_map_map_iterator (_tmp0_);
#line 290 "engine.vala"
	iter = _tmp1_;
#line 291 "engine.vala"
	while (TRUE) {
#line 1002 "engine.c"
		GeeMapIterator* _tmp2_;
		KkcInputMode input_mode = 0;
		GeeMapIterator* _tmp3_;
		gpointer _tmp4_;
		IBusProperty* prop = NULL;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		KkcContext* _tmp7_;
		KkcInputMode _tmp8_;
		KkcInputMode _tmp9_;
		gboolean _tmp14_ = FALSE;
#line 291 "engine.vala"
		_tmp2_ = iter;
#line 291 "engine.vala"
		if (!gee_map_iterator_next (_tmp2_)) {
#line 291 "engine.vala"
			break;
#line 1020 "engine.c"
		}
#line 292 "engine.vala"
		_tmp3_ = iter;
#line 292 "engine.vala"
		_tmp4_ = gee_map_iterator_get_key (_tmp3_);
#line 292 "engine.vala"
		input_mode = (KkcInputMode) ((gintptr) _tmp4_);
#line 293 "engine.vala"
		_tmp5_ = iter;
#line 293 "engine.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 293 "engine.vala"
		prop = (IBusProperty*) _tmp6_;
#line 295 "engine.vala"
		changed = FALSE;
#line 296 "engine.vala"
		_tmp7_ = self->priv->context;
#line 296 "engine.vala"
		_tmp8_ = kkc_context_get_input_mode (_tmp7_);
#line 296 "engine.vala"
		_tmp9_ = _tmp8_;
#line 296 "engine.vala"
		if (input_mode == _tmp9_) {
#line 1044 "engine.c"
			IBusProperty* _tmp10_;
#line 297 "engine.vala"
			_tmp10_ = prop;
#line 297 "engine.vala"
			if (ibus_property_get_state (_tmp10_) == PROP_STATE_UNCHECKED) {
#line 1050 "engine.c"
				IBusProperty* _tmp11_;
#line 298 "engine.vala"
				_tmp11_ = prop;
#line 298 "engine.vala"
				ibus_property_set_state (_tmp11_, PROP_STATE_CHECKED);
#line 299 "engine.vala"
				changed = TRUE;
#line 1058 "engine.c"
			}
		} else {
			IBusProperty* _tmp12_;
#line 302 "engine.vala"
			_tmp12_ = prop;
#line 302 "engine.vala"
			if (ibus_property_get_state (_tmp12_) == PROP_STATE_CHECKED) {
#line 1066 "engine.c"
				IBusProperty* _tmp13_;
#line 303 "engine.vala"
				_tmp13_ = prop;
#line 303 "engine.vala"
				ibus_property_set_state (_tmp13_, PROP_STATE_UNCHECKED);
#line 304 "engine.vala"
				changed = TRUE;
#line 1074 "engine.c"
			}
		}
#line 307 "engine.vala"
		if (changed) {
#line 307 "engine.vala"
			_tmp14_ = self->priv->properties_registered;
#line 1081 "engine.c"
		} else {
#line 307 "engine.vala"
			_tmp14_ = FALSE;
#line 1085 "engine.c"
		}
#line 307 "engine.vala"
		if (_tmp14_) {
#line 1089 "engine.c"
			IBusProperty* _tmp15_;
#line 308 "engine.vala"
			_tmp15_ = prop;
#line 308 "engine.vala"
			ibus_engine_update_property ((IBusEngine*) self, _tmp15_);
#line 1095 "engine.c"
		}
#line 291 "engine.vala"
		_g_object_unref0 (prop);
#line 1099 "engine.c"
	}
#line 312 "engine.vala"
	changed = FALSE;
#line 313 "engine.vala"
	_tmp16_ = self->priv->input_mode_symbols;
#line 313 "engine.vala"
	_tmp17_ = self->priv->context;
#line 313 "engine.vala"
	_tmp18_ = kkc_context_get_input_mode (_tmp17_);
#line 313 "engine.vala"
	_tmp19_ = _tmp18_;
#line 313 "engine.vala"
	_tmp20_ = gee_map_get (_tmp16_, (gpointer) ((gintptr) _tmp19_));
#line 313 "engine.vala"
	_tmp21_ = (gchar*) _tmp20_;
#line 313 "engine.vala"
	_tmp22_ = ibus_text_new_from_string (_tmp21_);
#line 313 "engine.vala"
	g_object_ref_sink (_tmp22_);
#line 313 "engine.vala"
	_tmp23_ = _tmp22_;
#line 313 "engine.vala"
	_g_free0 (_tmp21_);
#line 313 "engine.vala"
	symbol = _tmp23_;
#line 315 "engine.vala"
	_tmp24_ = symbol;
#line 315 "engine.vala"
	_tmp25_ = _tmp24_->text;
#line 315 "engine.vala"
	_tmp26_ = g_strdup_printf (_ ("Input Mode (%s)"), _tmp25_);
#line 315 "engine.vala"
	_tmp27_ = _tmp26_;
#line 315 "engine.vala"
	_tmp28_ = ibus_text_new_from_string (_tmp27_);
#line 315 "engine.vala"
	g_object_ref_sink (_tmp28_);
#line 315 "engine.vala"
	_tmp29_ = _tmp28_;
#line 315 "engine.vala"
	_g_free0 (_tmp27_);
#line 315 "engine.vala"
	label = _tmp29_;
#line 317 "engine.vala"
	_tmp30_ = self->priv->input_mode_prop;
#line 317 "engine.vala"
	_tmp31_ = ibus_property_get_symbol (_tmp30_);
#line 317 "engine.vala"
	_tmp32_ = symbol;
#line 317 "engine.vala"
	if (_tmp31_ != _tmp32_) {
#line 1151 "engine.c"
		IBusProperty* _tmp33_;
		IBusText* _tmp34_;
#line 318 "engine.vala"
		_tmp33_ = self->priv->input_mode_prop;
#line 318 "engine.vala"
		_tmp34_ = symbol;
#line 318 "engine.vala"
		ibus_property_set_symbol (_tmp33_, _tmp34_);
#line 319 "engine.vala"
		changed = TRUE;
#line 1162 "engine.c"
	}
#line 321 "engine.vala"
	_tmp35_ = self->priv->input_mode_prop;
#line 321 "engine.vala"
	_tmp36_ = ibus_property_get_label (_tmp35_);
#line 321 "engine.vala"
	_tmp37_ = label;
#line 321 "engine.vala"
	if (_tmp36_ != _tmp37_) {
#line 1172 "engine.c"
		IBusProperty* _tmp38_;
		IBusText* _tmp39_;
#line 322 "engine.vala"
		_tmp38_ = self->priv->input_mode_prop;
#line 322 "engine.vala"
		_tmp39_ = label;
#line 322 "engine.vala"
		ibus_property_set_label (_tmp38_, _tmp39_);
#line 323 "engine.vala"
		changed = TRUE;
#line 1183 "engine.c"
	}
#line 325 "engine.vala"
	if (changed) {
#line 325 "engine.vala"
		_tmp40_ = self->priv->properties_registered;
#line 1189 "engine.c"
	} else {
#line 325 "engine.vala"
		_tmp40_ = FALSE;
#line 1193 "engine.c"
	}
#line 325 "engine.vala"
	if (_tmp40_) {
#line 1197 "engine.c"
		IBusProperty* _tmp41_;
#line 326 "engine.vala"
		_tmp41_ = self->priv->input_mode_prop;
#line 326 "engine.vala"
		ibus_engine_update_property ((IBusEngine*) self, _tmp41_);
#line 1203 "engine.c"
	}
#line 286 "engine.vala"
	_g_object_unref0 (label);
#line 286 "engine.vala"
	_g_object_unref0 (symbol);
#line 286 "engine.vala"
	_g_object_unref0 (iter);
#line 1211 "engine.c"
}

static void
kkc_engine_reload_dictionaries (void)
{
	GeeArrayList* _tmp0_;
	GVariant* variant = NULL;
	Preferences* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	Preferences* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	gchar** strv = NULL;
	GVariant* _tmp16_;
	gsize _tmp17_ = 0;
	gchar** _tmp18_;
	gint strv_length1;
	gint _strv_size_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	GError* _inner_error0_ = NULL;
#line 330 "engine.vala"
	_tmp0_ = kkc_engine_dictionaries;
#line 330 "engine.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 333 "engine.vala"
	_tmp1_ = kkc_engine_preferences;
#line 333 "engine.vala"
	_tmp2_ = preferences_get (_tmp1_, "user_dictionary");
#line 333 "engine.vala"
	_g_variant_unref0 (variant);
#line 333 "engine.vala"
	variant = _tmp2_;
#line 334 "engine.vala"
	_tmp3_ = variant;
#line 334 "engine.vala"
	if (_tmp3_ != NULL) {
#line 1250 "engine.c"
		{
			KkcUserDictionary* _tmp4_ = NULL;
			GVariant* _tmp5_;
			const gchar* _tmp6_;
			KkcUserDictionary* _tmp7_;
			GeeArrayList* _tmp8_;
#line 336 "engine.vala"
			_tmp5_ = variant;
#line 336 "engine.vala"
			_tmp6_ = g_variant_get_string (_tmp5_, NULL);
#line 336 "engine.vala"
			_tmp7_ = kkc_user_dictionary_new (_tmp6_, &_inner_error0_);
#line 336 "engine.vala"
			_tmp4_ = _tmp7_;
#line 336 "engine.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1267 "engine.c"
				goto __catch0_g_error;
			}
#line 336 "engine.vala"
			_tmp8_ = kkc_engine_dictionaries;
#line 336 "engine.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, (KkcDictionary*) _tmp4_);
#line 335 "engine.vala"
			_g_object_unref0 (_tmp4_);
#line 1276 "engine.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GVariant* _tmp9_;
			const gchar* _tmp10_;
			GError* _tmp11_;
			const gchar* _tmp12_;
#line 335 "engine.vala"
			e = _inner_error0_;
#line 335 "engine.vala"
			_inner_error0_ = NULL;
#line 339 "engine.vala"
			_tmp9_ = variant;
#line 339 "engine.vala"
			_tmp10_ = g_variant_get_string (_tmp9_, NULL);
#line 339 "engine.vala"
			_tmp11_ = e;
#line 339 "engine.vala"
			_tmp12_ = _tmp11_->message;
#line 339 "engine.vala"
			g_warning ("engine.vala:339: can't load user dictionary %s: %s", _tmp10_, _tmp12_);
#line 335 "engine.vala"
			_g_error_free0 (e);
#line 1302 "engine.c"
		}
		__finally0:
#line 335 "engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 335 "engine.vala"
			_g_variant_unref0 (variant);
#line 335 "engine.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 335 "engine.vala"
			g_clear_error (&_inner_error0_);
#line 335 "engine.vala"
			return;
#line 1315 "engine.c"
		}
	}
#line 345 "engine.vala"
	_tmp13_ = kkc_engine_preferences;
#line 345 "engine.vala"
	_tmp14_ = preferences_get (_tmp13_, "system_dictionaries");
#line 345 "engine.vala"
	_g_variant_unref0 (variant);
#line 345 "engine.vala"
	variant = _tmp14_;
#line 346 "engine.vala"
	_tmp15_ = variant;
#line 346 "engine.vala"
	_vala_assert (_tmp15_ != NULL, "variant != null");
#line 347 "engine.vala"
	_tmp16_ = variant;
#line 347 "engine.vala"
	_tmp18_ = g_variant_dup_strv (_tmp16_, &_tmp17_);
#line 347 "engine.vala"
	strv = _tmp18_;
#line 347 "engine.vala"
	strv_length1 = _tmp17_;
#line 347 "engine.vala"
	_strv_size_ = strv_length1;
#line 348 "engine.vala"
	_tmp19_ = strv;
#line 348 "engine.vala"
	_tmp19__length1 = strv_length1;
#line 1344 "engine.c"
	{
		gchar** id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 348 "engine.vala"
		id_collection = _tmp19_;
#line 348 "engine.vala"
		id_collection_length1 = _tmp19__length1;
#line 348 "engine.vala"
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
#line 1356 "engine.c"
			gchar* _tmp20_;
			gchar* id = NULL;
#line 348 "engine.vala"
			_tmp20_ = g_strdup (id_collection[id_it]);
#line 348 "engine.vala"
			id = _tmp20_;
#line 1363 "engine.c"
			{
				DictionaryMetadata* metadata = NULL;
				Preferences* _tmp21_;
				const gchar* _tmp22_;
				DictionaryMetadata* _tmp23_;
#line 349 "engine.vala"
				_tmp21_ = kkc_engine_preferences;
#line 349 "engine.vala"
				_tmp22_ = id;
#line 349 "engine.vala"
				_tmp23_ = preferences_get_dictionary_metadata (_tmp21_, _tmp22_);
#line 349 "engine.vala"
				metadata = _tmp23_;
#line 1377 "engine.c"
				{
					KkcSystemSegmentDictionary* _tmp24_ = NULL;
					DictionaryMetadata* _tmp25_;
					const gchar* _tmp26_;
					const gchar* _tmp27_;
					DictionaryMetadata* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					KkcSystemSegmentDictionary* _tmp31_;
					GeeArrayList* _tmp32_;
#line 352 "engine.vala"
					_tmp25_ = metadata;
#line 352 "engine.vala"
					_tmp26_ = dictionary_metadata_get_filename (_tmp25_);
#line 352 "engine.vala"
					_tmp27_ = _tmp26_;
#line 352 "engine.vala"
					_tmp28_ = metadata;
#line 352 "engine.vala"
					_tmp29_ = dictionary_metadata_get_encoding (_tmp28_);
#line 352 "engine.vala"
					_tmp30_ = _tmp29_;
#line 352 "engine.vala"
					_tmp31_ = kkc_system_segment_dictionary_new (_tmp27_, _tmp30_, &_inner_error0_);
#line 352 "engine.vala"
					_tmp24_ = _tmp31_;
#line 352 "engine.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1406 "engine.c"
						goto __catch1_g_error;
					}
#line 351 "engine.vala"
					_tmp32_ = kkc_engine_dictionaries;
#line 351 "engine.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, (KkcDictionary*) _tmp24_);
#line 350 "engine.vala"
					_g_object_unref0 (_tmp24_);
#line 1415 "engine.c"
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					DictionaryMetadata* _tmp33_;
					const gchar* _tmp34_;
					const gchar* _tmp35_;
					GError* _tmp36_;
					const gchar* _tmp37_;
#line 350 "engine.vala"
					e = _inner_error0_;
#line 350 "engine.vala"
					_inner_error0_ = NULL;
#line 355 "engine.vala"
					_tmp33_ = metadata;
#line 355 "engine.vala"
					_tmp34_ = dictionary_metadata_get_filename (_tmp33_);
#line 355 "engine.vala"
					_tmp35_ = _tmp34_;
#line 355 "engine.vala"
					_tmp36_ = e;
#line 355 "engine.vala"
					_tmp37_ = _tmp36_->message;
#line 355 "engine.vala"
					g_warning ("engine.vala:355: can't load system dictionary %s: %s", _tmp35_, _tmp37_);
#line 350 "engine.vala"
					_g_error_free0 (e);
#line 1444 "engine.c"
				}
				__finally1:
#line 350 "engine.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 350 "engine.vala"
					_g_object_unref0 (metadata);
#line 350 "engine.vala"
					_g_free0 (id);
#line 350 "engine.vala"
					strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 350 "engine.vala"
					_g_variant_unref0 (variant);
#line 350 "engine.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 350 "engine.vala"
					g_clear_error (&_inner_error0_);
#line 350 "engine.vala"
					return;
#line 1463 "engine.c"
				}
#line 348 "engine.vala"
				_g_object_unref0 (metadata);
#line 348 "engine.vala"
				_g_free0 (id);
#line 1469 "engine.c"
			}
		}
	}
#line 329 "engine.vala"
	strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 329 "engine.vala"
	_g_variant_unref0 (variant);
#line 1477 "engine.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 415 "engine.vala"
	return self ? g_object_ref (self) : NULL;
#line 1485 "engine.c"
}

static void
kkc_engine_apply_preferences (KkcEngine* self)
{
	GVariant* variant = NULL;
	Preferences* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	KkcContext* _tmp3_;
	GVariant* _tmp4_;
	Preferences* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	KkcContext* _tmp8_;
	GVariant* _tmp9_;
	Preferences* _tmp10_;
	GVariant* _tmp11_;
	GVariant* _tmp12_;
	KkcContext* _tmp13_;
	KkcCandidateList* _tmp14_;
	KkcCandidateList* _tmp15_;
	GVariant* _tmp16_;
	IBusLookupTable* _tmp17_;
	GVariant* _tmp18_;
	Preferences* _tmp19_;
	GVariant* _tmp20_;
	GVariant* _tmp21_;
	KkcContext* _tmp22_;
	KkcCandidateList* _tmp23_;
	KkcCandidateList* _tmp24_;
	GVariant* _tmp25_;
	Preferences* _tmp26_;
	GVariant* _tmp27_;
	GVariant* _tmp28_;
	KkcContext* _tmp29_;
	GVariant* _tmp30_;
	Preferences* _tmp31_;
	GVariant* _tmp32_;
	GVariant* _tmp33_;
	GVariant* _tmp34_;
	Preferences* _tmp35_;
	GVariant* _tmp36_;
	GVariant* _tmp37_;
	KkcRuleMetadata* parent_metadata = NULL;
	GVariant* _tmp38_;
	const gchar* _tmp39_;
	KkcRuleMetadata* _tmp40_;
	gchar* base_dir = NULL;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	Preferences* _tmp50_;
	GVariant* _tmp51_;
	GVariant* _tmp52_;
	GVariant* _tmp53_;
	Preferences* _tmp54_;
	GVariant* _tmp55_;
	GVariant* _tmp56_;
	GVariant* _tmp57_;
	const gchar* _tmp58_;
	IBusKeymap* _tmp59_;
	IBusKeymap* _tmp60_;
	GError* _inner_error0_ = NULL;
#line 362 "engine.vala"
	g_return_if_fail (self != NULL);
#line 365 "engine.vala"
	_tmp0_ = kkc_engine_preferences;
#line 365 "engine.vala"
	_tmp1_ = preferences_get (_tmp0_, "punctuation_style");
#line 365 "engine.vala"
	_g_variant_unref0 (variant);
#line 365 "engine.vala"
	variant = _tmp1_;
#line 366 "engine.vala"
	_tmp2_ = variant;
#line 366 "engine.vala"
	_vala_assert (_tmp2_ != NULL, "variant != null");
#line 367 "engine.vala"
	_tmp3_ = self->priv->context;
#line 367 "engine.vala"
	_tmp4_ = variant;
#line 367 "engine.vala"
	kkc_context_set_punctuation_style (_tmp3_, (KkcPunctuationStyle) g_variant_get_int32 (_tmp4_));
#line 369 "engine.vala"
	_tmp5_ = kkc_engine_preferences;
#line 369 "engine.vala"
	_tmp6_ = preferences_get (_tmp5_, "auto_correct");
#line 369 "engine.vala"
	_g_variant_unref0 (variant);
#line 369 "engine.vala"
	variant = _tmp6_;
#line 370 "engine.vala"
	_tmp7_ = variant;
#line 370 "engine.vala"
	_vala_assert (_tmp7_ != NULL, "variant != null");
#line 371 "engine.vala"
	_tmp8_ = self->priv->context;
#line 371 "engine.vala"
	_tmp9_ = variant;
#line 371 "engine.vala"
	kkc_context_set_auto_correct (_tmp8_, g_variant_get_boolean (_tmp9_));
#line 373 "engine.vala"
	_tmp10_ = kkc_engine_preferences;
#line 373 "engine.vala"
	_tmp11_ = preferences_get (_tmp10_, "page_size");
#line 373 "engine.vala"
	_g_variant_unref0 (variant);
#line 373 "engine.vala"
	variant = _tmp11_;
#line 374 "engine.vala"
	_tmp12_ = variant;
#line 374 "engine.vala"
	_vala_assert (_tmp12_ != NULL, "variant != null");
#line 375 "engine.vala"
	_tmp13_ = self->priv->context;
#line 375 "engine.vala"
	_tmp14_ = kkc_context_get_candidates (_tmp13_);
#line 375 "engine.vala"
	_tmp15_ = _tmp14_;
#line 375 "engine.vala"
	_tmp16_ = variant;
#line 375 "engine.vala"
	kkc_candidate_list_set_page_size (_tmp15_, (guint) g_variant_get_int32 (_tmp16_));
#line 376 "engine.vala"
	_tmp17_ = self->priv->lookup_table;
#line 376 "engine.vala"
	_tmp18_ = variant;
#line 376 "engine.vala"
	ibus_lookup_table_set_page_size (_tmp17_, (guint) g_variant_get_int32 (_tmp18_));
#line 378 "engine.vala"
	_tmp19_ = kkc_engine_preferences;
#line 378 "engine.vala"
	_tmp20_ = preferences_get (_tmp19_, "pagination_start");
#line 378 "engine.vala"
	_g_variant_unref0 (variant);
#line 378 "engine.vala"
	variant = _tmp20_;
#line 379 "engine.vala"
	_tmp21_ = variant;
#line 379 "engine.vala"
	_vala_assert (_tmp21_ != NULL, "variant != null");
#line 380 "engine.vala"
	_tmp22_ = self->priv->context;
#line 380 "engine.vala"
	_tmp23_ = kkc_context_get_candidates (_tmp22_);
#line 380 "engine.vala"
	_tmp24_ = _tmp23_;
#line 380 "engine.vala"
	_tmp25_ = variant;
#line 380 "engine.vala"
	kkc_candidate_list_set_page_start (_tmp24_, (guint) g_variant_get_int32 (_tmp25_));
#line 382 "engine.vala"
	_tmp26_ = kkc_engine_preferences;
#line 382 "engine.vala"
	_tmp27_ = preferences_get (_tmp26_, "initial_input_mode");
#line 382 "engine.vala"
	_g_variant_unref0 (variant);
#line 382 "engine.vala"
	variant = _tmp27_;
#line 383 "engine.vala"
	_tmp28_ = variant;
#line 383 "engine.vala"
	_vala_assert (_tmp28_ != NULL, "variant != null");
#line 384 "engine.vala"
	_tmp29_ = self->priv->context;
#line 384 "engine.vala"
	_tmp30_ = variant;
#line 384 "engine.vala"
	kkc_context_set_input_mode (_tmp29_, (KkcInputMode) g_variant_get_int32 (_tmp30_));
#line 386 "engine.vala"
	_tmp31_ = kkc_engine_preferences;
#line 386 "engine.vala"
	_tmp32_ = preferences_get (_tmp31_, "show_annotation");
#line 386 "engine.vala"
	_g_variant_unref0 (variant);
#line 386 "engine.vala"
	variant = _tmp32_;
#line 387 "engine.vala"
	_tmp33_ = variant;
#line 387 "engine.vala"
	_vala_assert (_tmp33_ != NULL, "variant != null");
#line 388 "engine.vala"
	_tmp34_ = variant;
#line 388 "engine.vala"
	self->priv->show_annotation = g_variant_get_boolean (_tmp34_);
#line 390 "engine.vala"
	_tmp35_ = kkc_engine_preferences;
#line 390 "engine.vala"
	_tmp36_ = preferences_get (_tmp35_, "typing_rule");
#line 390 "engine.vala"
	_g_variant_unref0 (variant);
#line 390 "engine.vala"
	variant = _tmp36_;
#line 391 "engine.vala"
	_tmp37_ = variant;
#line 391 "engine.vala"
	_vala_assert (_tmp37_ != NULL, "variant != null");
#line 393 "engine.vala"
	_tmp38_ = variant;
#line 393 "engine.vala"
	_tmp39_ = g_variant_get_string (_tmp38_, NULL);
#line 393 "engine.vala"
	_tmp40_ = kkc_rule_metadata_find (_tmp39_);
#line 393 "engine.vala"
	parent_metadata = _tmp40_;
#line 394 "engine.vala"
	_vala_assert (parent_metadata != NULL, "parent_metadata != null");
#line 396 "engine.vala"
	_tmp41_ = g_get_user_config_dir ();
#line 396 "engine.vala"
	_tmp42_ = g_build_filename (_tmp41_, "ibus-kkc", "rules", NULL);
#line 396 "engine.vala"
	base_dir = _tmp42_;
#line 1699 "engine.c"
	{
		KkcUserRule* _tmp43_ = NULL;
		KkcUserRule* _tmp44_;
		KkcContext* _tmp45_;
#line 401 "engine.vala"
		_tmp44_ = kkc_user_rule_new (parent_metadata, base_dir, "ibus-kkc", &_inner_error0_);
#line 401 "engine.vala"
		_tmp43_ = _tmp44_;
#line 401 "engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1710 "engine.c"
			goto __catch0_g_error;
		}
#line 401 "engine.vala"
		_tmp45_ = self->priv->context;
#line 401 "engine.vala"
		kkc_context_set_typing_rule (_tmp45_, (KkcRule*) _tmp43_);
#line 400 "engine.vala"
		_g_object_unref0 (_tmp43_);
#line 1719 "engine.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GVariant* _tmp46_;
		const gchar* _tmp47_;
		GError* _tmp48_;
		const gchar* _tmp49_;
#line 400 "engine.vala"
		e = _inner_error0_;
#line 400 "engine.vala"
		_inner_error0_ = NULL;
#line 405 "engine.vala"
		_tmp46_ = variant;
#line 405 "engine.vala"
		_tmp47_ = g_variant_get_string (_tmp46_, NULL);
#line 405 "engine.vala"
		_tmp48_ = e;
#line 405 "engine.vala"
		_tmp49_ = _tmp48_->message;
#line 405 "engine.vala"
		g_warning ("engine.vala:405: can't load typing rule %s: %s", _tmp47_, _tmp49_);
#line 400 "engine.vala"
		_g_error_free0 (e);
#line 1745 "engine.c"
	}
	__finally0:
#line 400 "engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 400 "engine.vala"
		_g_free0 (base_dir);
#line 400 "engine.vala"
		_g_object_unref0 (parent_metadata);
#line 400 "engine.vala"
		_g_variant_unref0 (variant);
#line 400 "engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 400 "engine.vala"
		g_clear_error (&_inner_error0_);
#line 400 "engine.vala"
		return;
#line 1762 "engine.c"
	}
#line 409 "engine.vala"
	_tmp50_ = kkc_engine_preferences;
#line 409 "engine.vala"
	_tmp51_ = preferences_get (_tmp50_, "use_custom_keymap");
#line 409 "engine.vala"
	_g_variant_unref0 (variant);
#line 409 "engine.vala"
	variant = _tmp51_;
#line 410 "engine.vala"
	_tmp52_ = variant;
#line 410 "engine.vala"
	_vala_assert (_tmp52_ != NULL, "variant != null");
#line 411 "engine.vala"
	_tmp53_ = variant;
#line 411 "engine.vala"
	self->priv->use_custom_keymap = g_variant_get_boolean (_tmp53_);
#line 413 "engine.vala"
	_tmp54_ = kkc_engine_preferences;
#line 413 "engine.vala"
	_tmp55_ = preferences_get (_tmp54_, "keymap");
#line 413 "engine.vala"
	_g_variant_unref0 (variant);
#line 413 "engine.vala"
	variant = _tmp55_;
#line 414 "engine.vala"
	_tmp56_ = variant;
#line 414 "engine.vala"
	_vala_assert (_tmp56_ != NULL, "variant != null");
#line 415 "engine.vala"
	_tmp57_ = variant;
#line 415 "engine.vala"
	_tmp58_ = g_variant_get_string (_tmp57_, NULL);
#line 415 "engine.vala"
	_tmp59_ = ibus_keymap_get (_tmp58_);
#line 415 "engine.vala"
	_tmp60_ = _g_object_ref0 (_tmp59_);
#line 415 "engine.vala"
	_g_object_unref0 (self->priv->keymap);
#line 415 "engine.vala"
	self->priv->keymap = _tmp60_;
#line 362 "engine.vala"
	_g_free0 (base_dir);
#line 362 "engine.vala"
	_g_object_unref0 (parent_metadata);
#line 362 "engine.vala"
	_g_variant_unref0 (variant);
#line 1810 "engine.c"
}

static IBusProperty*
kkc_engine_register_input_mode_property (KkcEngine* self,
                                         KkcInputMode mode,
                                         const gchar* name,
                                         const gchar* label,
                                         const gchar* symbol)
{
	IBusProperty* prop = NULL;
	IBusText* _tmp0_;
	IBusText* _tmp1_;
	IBusProperty* _tmp2_;
	IBusProperty* _tmp3_;
	GeeMap* _tmp4_;
	GeeMap* _tmp5_;
	GeeMap* _tmp6_;
	IBusProperty* result;
#line 418 "engine.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 418 "engine.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 418 "engine.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 418 "engine.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 423 "engine.vala"
	_tmp0_ = ibus_text_new_from_string (label);
#line 423 "engine.vala"
	g_object_ref_sink (_tmp0_);
#line 423 "engine.vala"
	_tmp1_ = _tmp0_;
#line 423 "engine.vala"
	_tmp2_ = ibus_property_new (name, PROP_TYPE_RADIO, _tmp1_, NULL, NULL, TRUE, TRUE, PROP_STATE_UNCHECKED, NULL);
#line 423 "engine.vala"
	g_object_ref_sink (_tmp2_);
#line 423 "engine.vala"
	_tmp3_ = _tmp2_;
#line 423 "engine.vala"
	_g_object_unref0 (_tmp1_);
#line 423 "engine.vala"
	prop = _tmp3_;
#line 432 "engine.vala"
	_tmp4_ = self->priv->input_mode_props;
#line 432 "engine.vala"
	gee_map_set (_tmp4_, (gpointer) ((gintptr) mode), prop);
#line 433 "engine.vala"
	_tmp5_ = self->priv->input_mode_symbols;
#line 433 "engine.vala"
	gee_map_set (_tmp5_, (gpointer) ((gintptr) mode), symbol);
#line 434 "engine.vala"
	_tmp6_ = self->priv->name_input_modes;
#line 434 "engine.vala"
	gee_map_set (_tmp6_, name, (gpointer) ((gintptr) mode));
#line 435 "engine.vala"
	result = prop;
#line 435 "engine.vala"
	return result;
#line 1869 "engine.c"
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1122 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1122 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1123 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1124 "glib-2.0.vapi"
	result = str;
#line 1124 "glib-2.0.vapi"
	return result;
#line 1888 "engine.c"
}

static gboolean
_vala_string_array_contains (const gchar* * stack,
                             gssize stack_length,
                             const const gchar* needle)
{
	gssize i;
#line 449 "engine.vala"
	for (i = 0; i < stack_length; i++) {
#line 449 "engine.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 449 "engine.vala"
			return TRUE;
#line 1903 "engine.c"
		}
	}
#line 449 "engine.vala"
	return FALSE;
#line 1908 "engine.c"
}

static gboolean
kkc_engine_process_lookup_table_key_event (KkcEngine* self,
                                           guint keyval,
                                           guint keycode,
                                           guint state)
{
	guint page_size = 0U;
	IBusLookupTable* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 443 "engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 447 "engine.vala"
	_tmp0_ = self->priv->lookup_table;
#line 447 "engine.vala"
	page_size = ibus_lookup_table_get_page_size (_tmp0_);
#line 448 "engine.vala"
	if (state == ((guint) 0)) {
#line 1929 "engine.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 449 "engine.vala"
		_tmp2_ = g_unichar_to_string ((gunichar) keyval);
#line 449 "engine.vala"
		_tmp3_ = _tmp2_;
#line 449 "engine.vala"
		_tmp1_ = _vala_string_array_contains (KKC_ENGINE_LOOKUP_TABLE_LABELS, G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS), _tmp3_);
#line 449 "engine.vala"
		_g_free0 (_tmp3_);
#line 1940 "engine.c"
	} else {
#line 448 "engine.vala"
		_tmp1_ = FALSE;
#line 1944 "engine.c"
	}
#line 448 "engine.vala"
	if (_tmp1_) {
#line 1948 "engine.c"
		gchar* label = NULL;
		gchar* _tmp4_;
#line 450 "engine.vala"
		_tmp4_ = g_unichar_to_string (g_unichar_tolower ((gunichar) keyval));
#line 450 "engine.vala"
		label = _tmp4_;
#line 1955 "engine.c"
		{
			gint index = 0;
#line 451 "engine.vala"
			index = 0;
#line 1960 "engine.c"
			{
				gboolean _tmp5_ = FALSE;
#line 451 "engine.vala"
				_tmp5_ = TRUE;
#line 451 "engine.vala"
				while (TRUE) {
#line 1967 "engine.c"
					const gchar* _tmp7_;
					const gchar* _tmp8_;
#line 451 "engine.vala"
					if (!_tmp5_) {
#line 1972 "engine.c"
						gint _tmp6_;
#line 453 "engine.vala"
						_tmp6_ = index;
#line 453 "engine.vala"
						index = _tmp6_ + 1;
#line 1978 "engine.c"
					}
#line 451 "engine.vala"
					_tmp5_ = FALSE;
#line 452 "engine.vala"
					if (!(index < MIN ((gint) page_size, G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS)))) {
#line 452 "engine.vala"
						break;
#line 1986 "engine.c"
					}
#line 454 "engine.vala"
					_tmp7_ = KKC_ENGINE_LOOKUP_TABLE_LABELS[index];
#line 454 "engine.vala"
					_tmp8_ = label;
#line 454 "engine.vala"
					if (g_strcmp0 (_tmp7_, _tmp8_) == 0) {
#line 1994 "engine.c"
						KkcContext* _tmp9_;
						KkcCandidateList* _tmp10_;
						KkcCandidateList* _tmp11_;
#line 455 "engine.vala"
						_tmp9_ = self->priv->context;
#line 455 "engine.vala"
						_tmp10_ = kkc_context_get_candidates (_tmp9_);
#line 455 "engine.vala"
						_tmp11_ = _tmp10_;
#line 455 "engine.vala"
						result = kkc_candidate_list_select_at (_tmp11_, (guint) index);
#line 455 "engine.vala"
						_g_free0 (label);
#line 455 "engine.vala"
						return result;
#line 2010 "engine.c"
					}
				}
			}
		}
#line 458 "engine.vala"
		result = FALSE;
#line 458 "engine.vala"
		_g_free0 (label);
#line 458 "engine.vala"
		return result;
#line 2021 "engine.c"
	}
#line 461 "engine.vala"
	if (state == ((guint) 0)) {
#line 2025 "engine.c"
		gboolean retval = FALSE;
#line 462 "engine.vala"
		retval = FALSE;
#line 463 "engine.vala"
		switch (keyval) {
#line 463 "engine.vala"
			case IBUS_Page_Up:
#line 463 "engine.vala"
			case IBUS_KP_Page_Up:
#line 2035 "engine.c"
			{
				KkcContext* _tmp12_;
				KkcCandidateList* _tmp13_;
				KkcCandidateList* _tmp14_;
#line 466 "engine.vala"
				_tmp12_ = self->priv->context;
#line 466 "engine.vala"
				_tmp13_ = kkc_context_get_candidates (_tmp12_);
#line 466 "engine.vala"
				_tmp14_ = _tmp13_;
#line 466 "engine.vala"
				retval = kkc_candidate_list_page_up (_tmp14_);
#line 467 "engine.vala"
				break;
#line 2050 "engine.c"
			}
#line 463 "engine.vala"
			case IBUS_Page_Down:
#line 463 "engine.vala"
			case IBUS_KP_Page_Down:
#line 2056 "engine.c"
			{
				KkcContext* _tmp15_;
				KkcCandidateList* _tmp16_;
				KkcCandidateList* _tmp17_;
#line 470 "engine.vala"
				_tmp15_ = self->priv->context;
#line 470 "engine.vala"
				_tmp16_ = kkc_context_get_candidates (_tmp15_);
#line 470 "engine.vala"
				_tmp17_ = _tmp16_;
#line 470 "engine.vala"
				retval = kkc_candidate_list_page_down (_tmp17_);
#line 471 "engine.vala"
				break;
#line 2071 "engine.c"
			}
#line 463 "engine.vala"
			case IBUS_Up:
#line 2075 "engine.c"
			{
				KkcContext* _tmp18_;
				KkcCandidateList* _tmp19_;
				KkcCandidateList* _tmp20_;
#line 473 "engine.vala"
				_tmp18_ = self->priv->context;
#line 473 "engine.vala"
				_tmp19_ = kkc_context_get_candidates (_tmp18_);
#line 473 "engine.vala"
				_tmp20_ = _tmp19_;
#line 473 "engine.vala"
				retval = kkc_candidate_list_cursor_up (_tmp20_);
#line 474 "engine.vala"
				break;
#line 2090 "engine.c"
			}
#line 463 "engine.vala"
			case IBUS_Down:
#line 2094 "engine.c"
			{
				KkcContext* _tmp21_;
				KkcCandidateList* _tmp22_;
				KkcCandidateList* _tmp23_;
#line 476 "engine.vala"
				_tmp21_ = self->priv->context;
#line 476 "engine.vala"
				_tmp22_ = kkc_context_get_candidates (_tmp21_);
#line 476 "engine.vala"
				_tmp23_ = _tmp22_;
#line 476 "engine.vala"
				retval = kkc_candidate_list_cursor_down (_tmp23_);
#line 477 "engine.vala"
				break;
#line 2109 "engine.c"
			}
			default:
			{
#line 479 "engine.vala"
				result = FALSE;
#line 479 "engine.vala"
				return result;
#line 2117 "engine.c"
			}
		}
#line 482 "engine.vala"
		if (retval) {
#line 483 "engine.vala"
			kkc_engine_set_lookup_table_cursor_pos (self);
#line 484 "engine.vala"
			kkc_engine_update_preedit (self);
#line 2126 "engine.c"
		}
#line 486 "engine.vala"
		result = TRUE;
#line 486 "engine.vala"
		return result;
#line 2132 "engine.c"
	}
#line 489 "engine.vala"
	result = FALSE;
#line 489 "engine.vala"
	return result;
#line 2138 "engine.c"
}

static gboolean
kkc_engine_real_process_key_event (IBusEngine* base,
                                   guint keyval,
                                   guint keycode,
                                   guint state)
{
	KkcEngine * self;
	guint _keyval = 0U;
	guint _state = 0U;
	gboolean _tmp1_ = FALSE;
	KkcContext* _tmp2_;
	KkcCandidateList* _tmp3_;
	KkcCandidateList* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	KkcKeyEvent* key = NULL;
	KkcKeyEvent* _tmp7_;
	gboolean retval = FALSE;
	KkcContext* _tmp8_;
	KkcKeyEvent* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean result;
#line 492 "engine.vala"
	self = (KkcEngine*) base;
#line 496 "engine.vala"
	_keyval = keyval;
#line 498 "engine.vala"
	if (self->priv->use_custom_keymap) {
#line 2173 "engine.c"
		IBusKeymap* _tmp0_;
#line 499 "engine.vala"
		_tmp0_ = self->priv->keymap;
#line 499 "engine.vala"
		_keyval = ibus_keymap_lookup_keysym (_tmp0_, (guint16) keycode, (guint32) state);
#line 2179 "engine.c"
	}
#line 503 "engine.vala"
	_state = state & ((((IBUS_SHIFT_MASK | IBUS_CONTROL_MASK) | IBUS_MOD1_MASK) | IBUS_MOD5_MASK) | IBUS_RELEASE_MASK);
#line 508 "engine.vala"
	_tmp2_ = self->priv->context;
#line 508 "engine.vala"
	_tmp3_ = kkc_context_get_candidates (_tmp2_);
#line 508 "engine.vala"
	_tmp4_ = _tmp3_;
#line 508 "engine.vala"
	_tmp5_ = kkc_candidate_list_get_page_visible (_tmp4_);
#line 508 "engine.vala"
	_tmp6_ = _tmp5_;
#line 508 "engine.vala"
	if (_tmp6_) {
#line 509 "engine.vala"
		_tmp1_ = kkc_engine_process_lookup_table_key_event (self, _keyval, keycode, _state);
#line 2197 "engine.c"
	} else {
#line 508 "engine.vala"
		_tmp1_ = FALSE;
#line 2201 "engine.c"
	}
#line 508 "engine.vala"
	if (_tmp1_) {
#line 510 "engine.vala"
		result = TRUE;
#line 510 "engine.vala"
		return result;
#line 2209 "engine.c"
	}
#line 513 "engine.vala"
	_tmp7_ = kkc_key_event_new_from_x_event (_keyval, keycode, (KkcModifierType) _state);
#line 513 "engine.vala"
	key = _tmp7_;
#line 517 "engine.vala"
	_tmp8_ = self->priv->context;
#line 517 "engine.vala"
	_tmp9_ = key;
#line 517 "engine.vala"
	retval = kkc_context_process_key_event (_tmp8_, _tmp9_);
#line 522 "engine.vala"
	if (!retval) {
#line 522 "engine.vala"
		_tmp14_ = self->priv->use_custom_keymap;
#line 2225 "engine.c"
	} else {
#line 522 "engine.vala"
		_tmp14_ = FALSE;
#line 2229 "engine.c"
	}
#line 522 "engine.vala"
	if (_tmp14_) {
#line 523 "engine.vala"
		_tmp13_ = _keyval != keyval;
#line 2235 "engine.c"
	} else {
#line 522 "engine.vala"
		_tmp13_ = FALSE;
#line 2239 "engine.c"
	}
#line 522 "engine.vala"
	if (_tmp13_) {
#line 524 "engine.vala"
		_tmp12_ = ((guint) 0x20) <= _keyval;
#line 2245 "engine.c"
	} else {
#line 522 "engine.vala"
		_tmp12_ = FALSE;
#line 2249 "engine.c"
	}
#line 522 "engine.vala"
	if (_tmp12_) {
#line 524 "engine.vala"
		_tmp11_ = _keyval <= ((guint) 0x7F);
#line 2255 "engine.c"
	} else {
#line 522 "engine.vala"
		_tmp11_ = FALSE;
#line 2259 "engine.c"
	}
#line 522 "engine.vala"
	if (_tmp11_) {
#line 525 "engine.vala"
		_tmp10_ = (state & IBUS_RELEASE_MASK) == ((guint) 0);
#line 2265 "engine.c"
	} else {
#line 522 "engine.vala"
		_tmp10_ = FALSE;
#line 2269 "engine.c"
	}
#line 522 "engine.vala"
	if (_tmp10_) {
#line 2273 "engine.c"
		GString* builder = NULL;
		GString* _tmp15_;
		GString* _tmp16_;
		IBusText* text = NULL;
		GString* _tmp17_;
		const gchar* _tmp18_;
		IBusText* _tmp19_;
		IBusText* _tmp20_;
#line 526 "engine.vala"
		_tmp15_ = g_string_new ("");
#line 526 "engine.vala"
		builder = _tmp15_;
#line 527 "engine.vala"
		_tmp16_ = builder;
#line 527 "engine.vala"
		g_string_append_c (_tmp16_, (gchar) _keyval);
#line 528 "engine.vala"
		_tmp17_ = builder;
#line 528 "engine.vala"
		_tmp18_ = _tmp17_->str;
#line 528 "engine.vala"
		_tmp19_ = ibus_text_new_from_string (_tmp18_);
#line 528 "engine.vala"
		g_object_ref_sink (_tmp19_);
#line 528 "engine.vala"
		text = _tmp19_;
#line 529 "engine.vala"
		_tmp20_ = text;
#line 529 "engine.vala"
		ibus_engine_commit_text ((IBusEngine*) self, _tmp20_);
#line 530 "engine.vala"
		result = TRUE;
#line 530 "engine.vala"
		_g_object_unref0 (text);
#line 530 "engine.vala"
		_g_string_free0 (builder);
#line 530 "engine.vala"
		_g_object_unref0 (key);
#line 530 "engine.vala"
		return result;
#line 2314 "engine.c"
	}
#line 533 "engine.vala"
	result = retval;
#line 533 "engine.vala"
	_g_object_unref0 (key);
#line 533 "engine.vala"
	return result;
#line 2322 "engine.c"
}

static gboolean
__lambda4_ (KkcEngine* self)
{
	KkcContext* _tmp0_;
	KkcDictionaryList* _tmp1_;
	KkcDictionaryList* _tmp2_;
	gboolean result;
#line 545 "engine.vala"
	_tmp0_ = self->priv->context;
#line 545 "engine.vala"
	_tmp1_ = kkc_context_get_dictionaries (_tmp0_);
#line 545 "engine.vala"
	_tmp2_ = _tmp1_;
#line 545 "engine.vala"
	kkc_dictionary_list_save (_tmp2_);
#line 546 "engine.vala"
	result = TRUE;
#line 546 "engine.vala"
	return result;
#line 2344 "engine.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ ((KkcEngine*) self);
#line 541 "engine.vala"
	return result;
#line 2354 "engine.c"
}

static void
kkc_engine_real_enable (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
#line 538 "engine.vala"
	self = (KkcEngine*) base;
#line 539 "engine.vala"
	_tmp0_ = self->priv->context;
#line 539 "engine.vala"
	kkc_context_reset (_tmp0_);
#line 541 "engine.vala"
	self->priv->save_dictionaries_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_LOW, (guint) 300, ___lambda4__gsource_func, g_object_ref (self), g_object_unref);
#line 549 "engine.vala"
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->enable (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
#line 2372 "engine.c"
}

static void
kkc_engine_real_disable (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcDictionaryList* _tmp1_;
	KkcDictionaryList* _tmp2_;
#line 552 "engine.vala"
	self = (KkcEngine*) base;
#line 553 "engine.vala"
	g_signal_emit_by_name ((IBusEngine*) self, "focus-out");
#line 555 "engine.vala"
	if (self->priv->save_dictionaries_timeout_id > ((guint) 0)) {
#line 556 "engine.vala"
		g_source_remove (self->priv->save_dictionaries_timeout_id);
#line 557 "engine.vala"
		self->priv->save_dictionaries_timeout_id = (guint) 0;
#line 2392 "engine.c"
	}
#line 559 "engine.vala"
	_tmp0_ = self->priv->context;
#line 559 "engine.vala"
	_tmp1_ = kkc_context_get_dictionaries (_tmp0_);
#line 559 "engine.vala"
	_tmp2_ = _tmp1_;
#line 559 "engine.vala"
	kkc_dictionary_list_save (_tmp2_);
#line 561 "engine.vala"
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->disable (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
#line 2404 "engine.c"
}

static void
kkc_engine_real_reset (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	IBusText* empty_text = NULL;
	IBusText* _tmp1_;
#line 564 "engine.vala"
	self = (KkcEngine*) base;
#line 565 "engine.vala"
	_tmp0_ = self->priv->context;
#line 565 "engine.vala"
	kkc_context_reset (_tmp0_);
#line 566 "engine.vala"
	_tmp1_ = ibus_text_new_from_static_string ("");
#line 566 "engine.vala"
	g_object_ref_sink (_tmp1_);
#line 566 "engine.vala"
	empty_text = _tmp1_;
#line 567 "engine.vala"
	ibus_engine_update_preedit_text ((IBusEngine*) self, empty_text, (guint) 0, FALSE);
#line 570 "engine.vala"
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->reset (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
#line 564 "engine.vala"
	_g_object_unref0 (empty_text);
#line 2432 "engine.c"
}

static void
kkc_engine_real_focus_in (IBusEngine* base)
{
	KkcEngine * self;
	IBusPropList* _tmp0_;
#line 573 "engine.vala"
	self = (KkcEngine*) base;
#line 574 "engine.vala"
	kkc_engine_update_input_mode (self);
#line 575 "engine.vala"
	_tmp0_ = self->priv->prop_list;
#line 575 "engine.vala"
	ibus_engine_register_properties ((IBusEngine*) self, _tmp0_);
#line 576 "engine.vala"
	self->priv->properties_registered = TRUE;
#line 577 "engine.vala"
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->focus_in (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
#line 2452 "engine.c"
}

static void
kkc_engine_real_focus_out (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
#line 580 "engine.vala"
	self = (KkcEngine*) base;
#line 581 "engine.vala"
	_tmp0_ = self->priv->context;
#line 581 "engine.vala"
	kkc_context_reset (_tmp0_);
#line 582 "engine.vala"
	ibus_engine_hide_preedit_text ((IBusEngine*) self);
#line 583 "engine.vala"
	ibus_engine_hide_lookup_table ((IBusEngine*) self);
#line 584 "engine.vala"
	self->priv->properties_registered = FALSE;
#line 585 "engine.vala"
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->focus_out (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
#line 2474 "engine.c"
}

static void
kkc_engine_real_property_activate (IBusEngine* base,
                                   const gchar* prop_name,
                                   guint prop_state)
{
	KkcEngine * self;
	GError* _inner_error0_ = NULL;
#line 588 "engine.vala"
	self = (KkcEngine*) base;
#line 588 "engine.vala"
	g_return_if_fail (prop_name != NULL);
#line 591 "engine.vala"
	if (g_strcmp0 (prop_name, "setup") == 0) {
#line 2490 "engine.c"
		gchar* filename = NULL;
		gchar* _tmp0_;
#line 592 "engine.vala"
		_tmp0_ = g_build_filename (LIBEXECDIR, "ibus-setup-kkc", NULL);
#line 592 "engine.vala"
		filename = _tmp0_;
#line 2497 "engine.c"
		{
			const gchar* _tmp1_;
#line 595 "engine.vala"
			_tmp1_ = filename;
#line 595 "engine.vala"
			g_spawn_command_line_async (_tmp1_, &_inner_error0_);
#line 595 "engine.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 595 "engine.vala"
				if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 2508 "engine.c"
					goto __catch0_g_spawn_error;
				}
#line 595 "engine.vala"
				_g_free0 (filename);
#line 595 "engine.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 595 "engine.vala"
				g_clear_error (&_inner_error0_);
#line 595 "engine.vala"
				return;
#line 2519 "engine.c"
			}
		}
		goto __finally0;
		__catch0_g_spawn_error:
		{
			GError* e = NULL;
			const gchar* _tmp2_;
			GError* _tmp3_;
			const gchar* _tmp4_;
#line 594 "engine.vala"
			e = _inner_error0_;
#line 594 "engine.vala"
			_inner_error0_ = NULL;
#line 597 "engine.vala"
			_tmp2_ = filename;
#line 597 "engine.vala"
			_tmp3_ = e;
#line 597 "engine.vala"
			_tmp4_ = _tmp3_->message;
#line 597 "engine.vala"
			g_warning ("engine.vala:597: can't spawn %s: %s", _tmp2_, _tmp4_);
#line 594 "engine.vala"
			_g_error_free0 (e);
#line 2543 "engine.c"
		}
		__finally0:
#line 594 "engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 594 "engine.vala"
			_g_free0 (filename);
#line 594 "engine.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 594 "engine.vala"
			g_clear_error (&_inner_error0_);
#line 594 "engine.vala"
			return;
#line 2556 "engine.c"
		}
#line 591 "engine.vala"
		_g_free0 (filename);
#line 2560 "engine.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 600 "engine.vala"
		if (g_str_has_prefix (prop_name, "InputMode.")) {
#line 601 "engine.vala"
			_tmp5_ = prop_state == ((guint) PROP_STATE_CHECKED);
#line 2567 "engine.c"
		} else {
#line 600 "engine.vala"
			_tmp5_ = FALSE;
#line 2571 "engine.c"
		}
#line 600 "engine.vala"
		if (_tmp5_) {
#line 2575 "engine.c"
			KkcContext* _tmp6_;
			GeeMap* _tmp7_;
			gpointer _tmp8_;
#line 602 "engine.vala"
			_tmp6_ = self->priv->context;
#line 602 "engine.vala"
			_tmp7_ = self->priv->name_input_modes;
#line 602 "engine.vala"
			_tmp8_ = gee_map_get (_tmp7_, prop_name);
#line 602 "engine.vala"
			kkc_context_set_input_mode (_tmp6_, (KkcInputMode) ((gintptr) _tmp8_));
#line 2587 "engine.c"
		}
	}
}

static void
kkc_engine_real_candidate_clicked (IBusEngine* base,
                                   guint index,
                                   guint button,
                                   guint state)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
#line 606 "engine.vala"
	self = (KkcEngine*) base;
#line 607 "engine.vala"
	_tmp0_ = self->priv->context;
#line 607 "engine.vala"
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
#line 607 "engine.vala"
	_tmp2_ = _tmp1_;
#line 607 "engine.vala"
	kkc_candidate_list_select_at (_tmp2_, index);
#line 2612 "engine.c"
}

static void
kkc_engine_real_cursor_up (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
#line 610 "engine.vala"
	self = (KkcEngine*) base;
#line 611 "engine.vala"
	_tmp0_ = self->priv->context;
#line 611 "engine.vala"
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
#line 611 "engine.vala"
	_tmp2_ = _tmp1_;
#line 611 "engine.vala"
	kkc_candidate_list_cursor_up (_tmp2_);
#line 2632 "engine.c"
}

static void
kkc_engine_real_cursor_down (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
#line 614 "engine.vala"
	self = (KkcEngine*) base;
#line 615 "engine.vala"
	_tmp0_ = self->priv->context;
#line 615 "engine.vala"
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
#line 615 "engine.vala"
	_tmp2_ = _tmp1_;
#line 615 "engine.vala"
	kkc_candidate_list_cursor_down (_tmp2_);
#line 2652 "engine.c"
}

static void
kkc_engine_real_page_up (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
#line 618 "engine.vala"
	self = (KkcEngine*) base;
#line 619 "engine.vala"
	_tmp0_ = self->priv->context;
#line 619 "engine.vala"
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
#line 619 "engine.vala"
	_tmp2_ = _tmp1_;
#line 619 "engine.vala"
	kkc_candidate_list_page_up (_tmp2_);
#line 2672 "engine.c"
}

static void
kkc_engine_real_page_down (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
#line 622 "engine.vala"
	self = (KkcEngine*) base;
#line 623 "engine.vala"
	_tmp0_ = self->priv->context;
#line 623 "engine.vala"
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
#line 623 "engine.vala"
	_tmp2_ = _tmp1_;
#line 623 "engine.vala"
	kkc_candidate_list_page_down (_tmp2_);
#line 2692 "engine.c"
}

static void
kkc_engine_real_set_content_type (IBusEngine* base,
                                  guint purpose,
                                  guint hints)
{
	KkcEngine * self;
#line 626 "engine.vala"
	self = (KkcEngine*) base;
#line 627 "engine.vala"
	switch (purpose) {
#line 627 "engine.vala"
		case IBUS_INPUT_PURPOSE_PASSWORD:
#line 627 "engine.vala"
		case IBUS_INPUT_PURPOSE_PIN:
#line 2709 "engine.c"
		{
			KkcContext* _tmp0_;
#line 630 "engine.vala"
			_tmp0_ = self->priv->context;
#line 630 "engine.vala"
			kkc_context_set_input_mode (_tmp0_, KKC_INPUT_MODE_DIRECT);
#line 631 "engine.vala"
			break;
#line 2718 "engine.c"
		}
#line 627 "engine.vala"
		case IBUS_INPUT_PURPOSE_ALPHA:
#line 627 "engine.vala"
		case IBUS_INPUT_PURPOSE_DIGITS:
#line 627 "engine.vala"
		case IBUS_INPUT_PURPOSE_NUMBER:
#line 627 "engine.vala"
		case IBUS_INPUT_PURPOSE_PHONE:
#line 627 "engine.vala"
		case IBUS_INPUT_PURPOSE_URL:
#line 627 "engine.vala"
		case IBUS_INPUT_PURPOSE_EMAIL:
#line 2732 "engine.c"
		{
			KkcContext* _tmp1_;
#line 638 "engine.vala"
			_tmp1_ = self->priv->context;
#line 638 "engine.vala"
			kkc_context_set_input_mode (_tmp1_, KKC_INPUT_MODE_LATIN);
#line 639 "engine.vala"
			break;
#line 2741 "engine.c"
		}
		default:
#line 627 "engine.vala"
		break;
#line 2746 "engine.c"
	}
}

static void
__lambda5_ (void)
{
#line 675 "engine.vala"
	ibus_quit ();
#line 2755 "engine.c"
}

static void
___lambda5__ibus_bus_disconnected (IBusBus* _sender,
                                   gpointer self)
{
#line 675 "engine.vala"
	__lambda5_ ();
#line 2764 "engine.c"
}

static void
__lambda6_ (const gchar* name,
            GVariant* value)
{
#line 693 "engine.vala"
	g_return_if_fail (name != NULL);
#line 693 "engine.vala"
	g_return_if_fail (value != NULL);
#line 694 "engine.vala"
	if (g_strcmp0 (name, "dictionaries") == 0) {
#line 695 "engine.vala"
		kkc_engine_reload_dictionaries ();
#line 2779 "engine.c"
	}
}

static void
___lambda6__preferences_value_changed (Preferences* _sender,
                                       const gchar* name,
                                       GVariant* value,
                                       gpointer self)
{
#line 693 "engine.vala"
	__lambda6_ (name, value);
#line 2791 "engine.c"
}

static gint
kkc_engine_main (gchar** args,
                 gint args_length1)
{
	GOptionContext* context = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	IBusBus* bus = NULL;
	IBusBus* _tmp8_;
	IBusBus* _tmp9_;
	IBusBus* _tmp11_;
	IBusConfig* config = NULL;
	IBusBus* _tmp12_;
	IBusConfig* _tmp13_;
	IBusConfig* _tmp14_;
	IBusConfig* _tmp15_;
	IBusConfig* _tmp24_;
	Preferences* _tmp25_;
	GeeArrayList* _tmp26_;
	Preferences* _tmp27_;
	IBusFactory* factory = NULL;
	IBusBus* _tmp28_;
	GDBusConnection* _tmp29_;
	IBusFactory* _tmp30_;
	IBusFactory* _tmp31_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 652 "engine.vala"
	ibus_init ();
#line 653 "engine.vala"
	kkc_init ();
#line 654 "engine.vala"
	gtk_init ((gint*) (&args_length1), &args);
#line 656 "engine.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 657 "engine.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 658 "engine.vala"
	textdomain (GETTEXT_PACKAGE);
#line 660 "engine.vala"
	_tmp0_ = g_option_context_new ("- ibus kkc");
#line 660 "engine.vala"
	context = _tmp0_;
#line 661 "engine.vala"
	_tmp1_ = context;
#line 661 "engine.vala"
	g_option_context_add_main_entries (_tmp1_, KKC_ENGINE_options, "ibus-kkc");
#line 2841 "engine.c"
	{
		GOptionContext* _tmp2_;
#line 663 "engine.vala"
		_tmp2_ = context;
#line 663 "engine.vala"
		g_option_context_parse (_tmp2_, (gint*) (&args_length1), &args, &_inner_error0_);
#line 663 "engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2850 "engine.c"
			gint _tmp3_ = -1;
#line 663 "engine.vala"
			if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 2854 "engine.c"
				goto __catch0_g_option_error;
			}
#line 663 "engine.vala"
			_g_option_context_free0 (context);
#line 663 "engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 663 "engine.vala"
			g_clear_error (&_inner_error0_);
#line 663 "engine.vala"
			return _tmp3_;
#line 2865 "engine.c"
		}
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 662 "engine.vala"
		e = _inner_error0_;
#line 662 "engine.vala"
		_inner_error0_ = NULL;
#line 665 "engine.vala"
		_tmp4_ = stderr;
#line 665 "engine.vala"
		_tmp5_ = e;
#line 665 "engine.vala"
		_tmp6_ = _tmp5_->message;
#line 665 "engine.vala"
		fprintf (_tmp4_, "%s\n", _tmp6_);
#line 666 "engine.vala"
		result = 1;
#line 666 "engine.vala"
		_g_error_free0 (e);
#line 666 "engine.vala"
		_g_option_context_free0 (context);
#line 666 "engine.vala"
		return result;
#line 2895 "engine.c"
	}
	__finally0:
#line 662 "engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2900 "engine.c"
		gint _tmp7_ = -1;
#line 662 "engine.vala"
		_g_option_context_free0 (context);
#line 662 "engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 662 "engine.vala"
		g_clear_error (&_inner_error0_);
#line 662 "engine.vala"
		return _tmp7_;
#line 2910 "engine.c"
	}
#line 669 "engine.vala"
	_tmp8_ = ibus_bus_new ();
#line 669 "engine.vala"
	g_object_ref_sink (_tmp8_);
#line 669 "engine.vala"
	bus = _tmp8_;
#line 670 "engine.vala"
	_tmp9_ = bus;
#line 670 "engine.vala"
	if (!ibus_bus_is_connected (_tmp9_)) {
#line 2922 "engine.c"
		FILE* _tmp10_;
#line 671 "engine.vala"
		_tmp10_ = stderr;
#line 671 "engine.vala"
		fprintf (_tmp10_, "cannot connect to ibus-daemon!\n");
#line 672 "engine.vala"
		result = 1;
#line 672 "engine.vala"
		_g_object_unref0 (bus);
#line 672 "engine.vala"
		_g_option_context_free0 (context);
#line 672 "engine.vala"
		return result;
#line 2936 "engine.c"
	}
#line 675 "engine.vala"
	_tmp11_ = bus;
#line 675 "engine.vala"
	g_signal_connect (_tmp11_, "disconnected", (GCallback) ___lambda5__ibus_bus_disconnected, NULL);
#line 677 "engine.vala"
	_tmp12_ = bus;
#line 677 "engine.vala"
	_tmp13_ = ibus_bus_get_config (_tmp12_);
#line 677 "engine.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 677 "engine.vala"
	config = _tmp14_;
#line 678 "engine.vala"
	_tmp15_ = config;
#line 678 "engine.vala"
	if (_tmp15_ == NULL) {
#line 2954 "engine.c"
		FILE* _tmp16_;
#line 679 "engine.vala"
		_tmp16_ = stderr;
#line 679 "engine.vala"
		fprintf (_tmp16_, "ibus-config component is not running!\n");
#line 680 "engine.vala"
		result = 1;
#line 680 "engine.vala"
		_g_object_unref0 (config);
#line 680 "engine.vala"
		_g_object_unref0 (bus);
#line 680 "engine.vala"
		_g_option_context_free0 (context);
#line 680 "engine.vala"
		return result;
#line 2970 "engine.c"
	}
	{
		KkcLanguageModel* _tmp17_ = NULL;
		KkcLanguageModel* _tmp18_;
		KkcLanguageModel* _tmp19_;
#line 684 "engine.vala"
		_tmp18_ = kkc_language_model_load ("sorted3", &_inner_error0_);
#line 684 "engine.vala"
		_tmp17_ = _tmp18_;
#line 684 "engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2982 "engine.c"
			goto __catch1_g_error;
		}
#line 684 "engine.vala"
		_tmp19_ = _tmp17_;
#line 684 "engine.vala"
		_tmp17_ = NULL;
#line 684 "engine.vala"
		_g_object_unref0 (kkc_engine_language_model);
#line 684 "engine.vala"
		kkc_engine_language_model = _tmp19_;
#line 683 "engine.vala"
		_g_object_unref0 (_tmp17_);
#line 2995 "engine.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		FILE* _tmp20_;
		GError* _tmp21_;
		const gchar* _tmp22_;
#line 683 "engine.vala"
		e = _inner_error0_;
#line 683 "engine.vala"
		_inner_error0_ = NULL;
#line 686 "engine.vala"
		_tmp20_ = stderr;
#line 686 "engine.vala"
		_tmp21_ = e;
#line 686 "engine.vala"
		_tmp22_ = _tmp21_->message;
#line 686 "engine.vala"
		fprintf (_tmp20_, "can't load language model: %s\n", _tmp22_);
#line 687 "engine.vala"
		result = 1;
#line 687 "engine.vala"
		_g_error_free0 (e);
#line 687 "engine.vala"
		_g_object_unref0 (config);
#line 687 "engine.vala"
		_g_object_unref0 (bus);
#line 687 "engine.vala"
		_g_option_context_free0 (context);
#line 687 "engine.vala"
		return result;
#line 3028 "engine.c"
	}
	__finally1:
#line 683 "engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3033 "engine.c"
		gint _tmp23_ = -1;
#line 683 "engine.vala"
		_g_object_unref0 (config);
#line 683 "engine.vala"
		_g_object_unref0 (bus);
#line 683 "engine.vala"
		_g_option_context_free0 (context);
#line 683 "engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 683 "engine.vala"
		g_clear_error (&_inner_error0_);
#line 683 "engine.vala"
		return _tmp23_;
#line 3047 "engine.c"
	}
#line 690 "engine.vala"
	_tmp24_ = config;
#line 690 "engine.vala"
	_tmp25_ = preferences_new (_tmp24_);
#line 690 "engine.vala"
	_g_object_unref0 (kkc_engine_preferences);
#line 690 "engine.vala"
	kkc_engine_preferences = _tmp25_;
#line 691 "engine.vala"
	_tmp26_ = gee_array_list_new (KKC_TYPE_DICTIONARY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 691 "engine.vala"
	_g_object_unref0 (kkc_engine_dictionaries);
#line 691 "engine.vala"
	kkc_engine_dictionaries = _tmp26_;
#line 692 "engine.vala"
	kkc_engine_reload_dictionaries ();
#line 693 "engine.vala"
	_tmp27_ = kkc_engine_preferences;
#line 693 "engine.vala"
	g_signal_connect (_tmp27_, "value-changed", (GCallback) ___lambda6__preferences_value_changed, NULL);
#line 699 "engine.vala"
	_tmp28_ = bus;
#line 699 "engine.vala"
	_tmp29_ = ibus_bus_get_connection (_tmp28_);
#line 699 "engine.vala"
	_tmp30_ = ibus_factory_new (_tmp29_);
#line 699 "engine.vala"
	g_object_ref_sink (_tmp30_);
#line 699 "engine.vala"
	factory = _tmp30_;
#line 700 "engine.vala"
	_tmp31_ = factory;
#line 700 "engine.vala"
	ibus_factory_add_engine (_tmp31_, "kkc", TYPE_KKC_ENGINE);
#line 701 "engine.vala"
	if (kkc_engine_ibus) {
#line 3085 "engine.c"
		IBusBus* _tmp32_;
#line 702 "engine.vala"
		_tmp32_ = bus;
#line 702 "engine.vala"
		ibus_bus_request_name (_tmp32_, "org.freedesktop.IBus.KKC", (guint32) 0);
#line 3091 "engine.c"
	} else {
		IBusComponent* component = NULL;
		IBusComponent* _tmp33_;
		IBusEngineDesc* engine = NULL;
		gchar* _tmp34_;
		gchar* _tmp35_;
		IBusEngineDesc* _tmp36_;
		IBusEngineDesc* _tmp37_;
		IBusComponent* _tmp38_;
		IBusEngineDesc* _tmp39_;
		IBusBus* _tmp40_;
		IBusComponent* _tmp41_;
#line 704 "engine.vala"
		_tmp33_ = ibus_component_new ("org.freedesktop.IBus.KKC", N_ ("Kana Kanji"), PACKAGE_VERSION, "GPL", "Daiki Ueno <ueno@gnu.org>", "https://github.com/ueno/ibus-kkc", "", "ibus-kkc");
#line 704 "engine.vala"
		g_object_ref_sink (_tmp33_);
#line 704 "engine.vala"
		component = _tmp33_;
#line 711 "engine.vala"
		_tmp34_ = g_strdup_printf ("%s/icons/ibus-kkc.svg", PACKAGE_DATADIR);
#line 711 "engine.vala"
		_tmp35_ = _tmp34_;
#line 711 "engine.vala"
		_tmp36_ = ibus_engine_desc_new ("kkc", "Kana Kanji", "Kana Kanji Input Method", "ja", "GPL", "Daiki Ueno <ueno@gnu.org>", _tmp35_, "us");
#line 711 "engine.vala"
		g_object_ref_sink (_tmp36_);
#line 711 "engine.vala"
		_tmp37_ = _tmp36_;
#line 711 "engine.vala"
		_g_free0 (_tmp35_);
#line 711 "engine.vala"
		engine = _tmp37_;
#line 720 "engine.vala"
		_tmp38_ = component;
#line 720 "engine.vala"
		_tmp39_ = engine;
#line 720 "engine.vala"
		ibus_component_add_engine (_tmp38_, _tmp39_);
#line 721 "engine.vala"
		_tmp40_ = bus;
#line 721 "engine.vala"
		_tmp41_ = component;
#line 721 "engine.vala"
		ibus_bus_register_component (_tmp40_, _tmp41_);
#line 701 "engine.vala"
		_g_object_unref0 (engine);
#line 701 "engine.vala"
		_g_object_unref0 (component);
#line 3140 "engine.c"
	}
#line 723 "engine.vala"
	ibus_main ();
#line 724 "engine.vala"
	result = 0;
#line 724 "engine.vala"
	_g_object_unref0 (factory);
#line 724 "engine.vala"
	_g_object_unref0 (config);
#line 724 "engine.vala"
	_g_object_unref0 (bus);
#line 724 "engine.vala"
	_g_option_context_free0 (context);
#line 724 "engine.vala"
	return result;
#line 3156 "engine.c"
}

int
main (int argc,
      char ** argv)
{
#line 651 "engine.vala"
	return kkc_engine_main (argv, argc);
#line 3165 "engine.c"
}

KkcEngine*
kkc_engine_construct (GType object_type)
{
	KkcEngine * self = NULL;
#line 22 "engine.vala"
	self = (KkcEngine*) g_object_new (object_type, NULL);
#line 22 "engine.vala"
	return self;
#line 3176 "engine.c"
}

KkcEngine*
kkc_engine_new (void)
{
#line 22 "engine.vala"
	return kkc_engine_construct (TYPE_KKC_ENGINE);
#line 3184 "engine.c"
}

static void
_kkc_engine___lambda7_ (KkcEngine* self,
                        const gchar* name,
                        GVariant* value)
{
#line 138 "engine.vala"
	g_return_if_fail (name != NULL);
#line 138 "engine.vala"
	g_return_if_fail (value != NULL);
#line 139 "engine.vala"
	kkc_engine_apply_preferences (self);
#line 140 "engine.vala"
	if (g_strcmp0 (name, "dictionaries") == 0) {
#line 3200 "engine.c"
		KkcContext* _tmp0_;
		KkcDictionaryList* _tmp1_;
		KkcDictionaryList* _tmp2_;
#line 142 "engine.vala"
		_tmp0_ = self->priv->context;
#line 142 "engine.vala"
		_tmp1_ = kkc_context_get_dictionaries (_tmp0_);
#line 142 "engine.vala"
		_tmp2_ = _tmp1_;
#line 142 "engine.vala"
		kkc_dictionary_list_clear (_tmp2_);
#line 3212 "engine.c"
		{
			GeeArrayList* _dictionary_list = NULL;
			GeeArrayList* _tmp3_;
			gint _dictionary_size = 0;
			GeeArrayList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _dictionary_index = 0;
#line 143 "engine.vala"
			_tmp3_ = kkc_engine_dictionaries;
#line 143 "engine.vala"
			_dictionary_list = _tmp3_;
#line 143 "engine.vala"
			_tmp4_ = _dictionary_list;
#line 143 "engine.vala"
			_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 143 "engine.vala"
			_tmp6_ = _tmp5_;
#line 143 "engine.vala"
			_dictionary_size = _tmp6_;
#line 143 "engine.vala"
			_dictionary_index = -1;
#line 143 "engine.vala"
			while (TRUE) {
#line 3237 "engine.c"
				gint _tmp7_;
				gint _tmp8_;
				KkcDictionary* dictionary = NULL;
				GeeArrayList* _tmp9_;
				gpointer _tmp10_;
				KkcContext* _tmp11_;
				KkcDictionaryList* _tmp12_;
				KkcDictionaryList* _tmp13_;
				KkcDictionary* _tmp14_;
#line 143 "engine.vala"
				_dictionary_index = _dictionary_index + 1;
#line 143 "engine.vala"
				_tmp7_ = _dictionary_index;
#line 143 "engine.vala"
				_tmp8_ = _dictionary_size;
#line 143 "engine.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 143 "engine.vala"
					break;
#line 3257 "engine.c"
				}
#line 143 "engine.vala"
				_tmp9_ = _dictionary_list;
#line 143 "engine.vala"
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _dictionary_index);
#line 143 "engine.vala"
				dictionary = (KkcDictionary*) _tmp10_;
#line 144 "engine.vala"
				_tmp11_ = self->priv->context;
#line 144 "engine.vala"
				_tmp12_ = kkc_context_get_dictionaries (_tmp11_);
#line 144 "engine.vala"
				_tmp13_ = _tmp12_;
#line 144 "engine.vala"
				_tmp14_ = dictionary;
#line 144 "engine.vala"
				kkc_dictionary_list_add (_tmp13_, _tmp14_);
#line 143 "engine.vala"
				_g_object_unref0 (dictionary);
#line 3277 "engine.c"
			}
		}
	}
}

static void
__kkc_engine___lambda7__preferences_value_changed (Preferences* _sender,
                                                   const gchar* name,
                                                   GVariant* value,
                                                   gpointer self)
{
#line 138 "engine.vala"
	_kkc_engine___lambda7_ ((KkcEngine*) self, name, value);
#line 3291 "engine.c"
}

static void
_kkc_engine___lambda8_ (KkcEngine* self)
{
#line 150 "engine.vala"
	kkc_engine_update_preedit (self);
#line 3299 "engine.c"
}

static void
__kkc_engine___lambda8__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self)
{
#line 149 "engine.vala"
	_kkc_engine___lambda8_ ((KkcEngine*) self);
#line 3309 "engine.c"
}

static void
_kkc_engine___lambda9_ (KkcEngine* self,
                        GObject* s,
                        GParamSpec* p)
{
#line 152 "engine.vala"
	g_return_if_fail (s != NULL);
#line 152 "engine.vala"
	g_return_if_fail (p != NULL);
#line 153 "engine.vala"
	kkc_engine_update_input_mode (self);
#line 3323 "engine.c"
}

static void
__kkc_engine___lambda9__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self)
{
#line 152 "engine.vala"
	_kkc_engine___lambda9_ ((KkcEngine*) self, _sender, pspec);
#line 3333 "engine.c"
}

static void
_kkc_engine___lambda10_ (KkcEngine* self)
{
#line 156 "engine.vala"
	kkc_engine_populate_lookup_table (self);
#line 3341 "engine.c"
}

static void
__kkc_engine___lambda10__kkc_candidate_list_populated (KkcCandidateList* _sender,
                                                       gpointer self)
{
#line 155 "engine.vala"
	_kkc_engine___lambda10_ ((KkcEngine*) self);
#line 3350 "engine.c"
}

static void
_kkc_engine___lambda11_ (KkcEngine* self)
{
#line 159 "engine.vala"
	kkc_engine_set_lookup_table_cursor_pos (self);
#line 3358 "engine.c"
}

static void
__kkc_engine___lambda11__g_object_notify (GObject* _sender,
                                          GParamSpec* pspec,
                                          gpointer self)
{
#line 158 "engine.vala"
	_kkc_engine___lambda11_ ((KkcEngine*) self);
#line 3368 "engine.c"
}

static void
_kkc_engine___lambda12_ (KkcEngine* self)
{
#line 162 "engine.vala"
	if (self->priv->lookup_table_visible) {
#line 163 "engine.vala"
		ibus_engine_hide_lookup_table ((IBusEngine*) self);
#line 164 "engine.vala"
		ibus_engine_hide_auxiliary_text ((IBusEngine*) self);
#line 165 "engine.vala"
		self->priv->lookup_table_visible = FALSE;
#line 3382 "engine.c"
	}
}

static void
__kkc_engine___lambda12__kkc_candidate_list_selected (KkcCandidateList* _sender,
                                                      KkcCandidate* candidate,
                                                      gpointer self)
{
#line 161 "engine.vala"
	_kkc_engine___lambda12_ ((KkcEngine*) self);
#line 3393 "engine.c"
}

static void
_kkc_engine___lambda13_ (KkcEngine* self,
                         KkcContext* e)
{
	GtkClipboard* _tmp0_;
#line 171 "engine.vala"
	g_return_if_fail (e != NULL);
#line 172 "engine.vala"
	_tmp0_ = self->priv->clipboard;
#line 172 "engine.vala"
	gtk_clipboard_request_text (_tmp0_, (GtkClipboardTextReceivedFunc) kkc_engine_set_selection_text, self);
#line 3407 "engine.c"
}

static void
__kkc_engine___lambda13__kkc_context_request_selection_text (KkcContext* _sender,
                                                             gpointer self)
{
#line 171 "engine.vala"
	_kkc_engine___lambda13_ ((KkcEngine*) self, _sender);
#line 3416 "engine.c"
}

static GObject *
kkc_engine_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	KkcEngine * self;
	IBusLookupTable* _tmp0_;
	IBusPropList* _tmp7_;
	IBusPropList* props = NULL;
	IBusPropList* _tmp8_;
	IBusProperty* prop = NULL;
	IBusProperty* _tmp9_;
	IBusPropList* _tmp10_;
	IBusProperty* _tmp11_;
	IBusProperty* _tmp12_;
	IBusPropList* _tmp13_;
	IBusProperty* _tmp14_;
	IBusProperty* _tmp15_;
	IBusPropList* _tmp16_;
	IBusProperty* _tmp17_;
	IBusProperty* _tmp18_;
	IBusPropList* _tmp19_;
	IBusProperty* _tmp20_;
	IBusProperty* _tmp21_;
	IBusPropList* _tmp22_;
	IBusProperty* _tmp23_;
	IBusProperty* _tmp24_;
	IBusPropList* _tmp25_;
	IBusProperty* _tmp26_;
	IBusText* _tmp27_;
	IBusText* _tmp28_;
	IBusText* _tmp29_;
	IBusText* _tmp30_;
	IBusPropList* _tmp31_;
	IBusProperty* _tmp32_;
	IBusPropList* _tmp33_;
	IBusProperty* _tmp34_;
	IBusProperty* _tmp35_;
	IBusProperty* _tmp36_;
	IBusText* _tmp37_;
	IBusText* _tmp38_;
	IBusText* _tmp39_;
	IBusText* _tmp40_;
	IBusProperty* _tmp41_;
	IBusPropList* _tmp42_;
	IBusProperty* _tmp43_;
	KkcLanguageModel* _tmp44_;
	KkcContext* _tmp45_;
	Preferences* _tmp58_;
	KkcContext* _tmp59_;
	KkcContext* _tmp60_;
	KkcContext* _tmp61_;
	KkcCandidateList* _tmp62_;
	KkcCandidateList* _tmp63_;
	KkcContext* _tmp64_;
	KkcCandidateList* _tmp65_;
	KkcCandidateList* _tmp66_;
	KkcContext* _tmp67_;
	KkcCandidateList* _tmp68_;
	KkcCandidateList* _tmp69_;
	GtkClipboard* _tmp70_;
	GtkClipboard* _tmp71_;
	KkcContext* _tmp72_;
#line 55 "engine.vala"
	parent_class = G_OBJECT_CLASS (kkc_engine_parent_class);
#line 55 "engine.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 55 "engine.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KKC_ENGINE, KkcEngine);
#line 57 "engine.vala"
	_tmp0_ = ibus_lookup_table_new ((guint) G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS), (guint) 0, TRUE, TRUE);
#line 57 "engine.vala"
	g_object_ref_sink (_tmp0_);
#line 57 "engine.vala"
	_g_object_unref0 (self->priv->lookup_table);
#line 57 "engine.vala"
	self->priv->lookup_table = _tmp0_;
#line 3498 "engine.c"
	{
		gint i = 0;
#line 59 "engine.vala"
		i = 0;
#line 3503 "engine.c"
		{
			gboolean _tmp1_ = FALSE;
#line 59 "engine.vala"
			_tmp1_ = TRUE;
#line 59 "engine.vala"
			while (TRUE) {
#line 3510 "engine.c"
				IBusText* text = NULL;
				const gchar* _tmp3_;
				IBusText* _tmp4_;
				IBusLookupTable* _tmp5_;
				IBusText* _tmp6_;
#line 59 "engine.vala"
				if (!_tmp1_) {
#line 3518 "engine.c"
					gint _tmp2_;
#line 59 "engine.vala"
					_tmp2_ = i;
#line 59 "engine.vala"
					i = _tmp2_ + 1;
#line 3524 "engine.c"
				}
#line 59 "engine.vala"
				_tmp1_ = FALSE;
#line 59 "engine.vala"
				if (!(i < G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS))) {
#line 59 "engine.vala"
					break;
#line 3532 "engine.c"
				}
#line 60 "engine.vala"
				_tmp3_ = KKC_ENGINE_LOOKUP_TABLE_LABELS[i];
#line 60 "engine.vala"
				_tmp4_ = ibus_text_new_from_string (_tmp3_);
#line 60 "engine.vala"
				g_object_ref_sink (_tmp4_);
#line 60 "engine.vala"
				text = _tmp4_;
#line 61 "engine.vala"
				_tmp5_ = self->priv->lookup_table;
#line 61 "engine.vala"
				_tmp6_ = text;
#line 61 "engine.vala"
				ibus_lookup_table_set_label (_tmp5_, (guint) i, _tmp6_);
#line 59 "engine.vala"
				_g_object_unref0 (text);
#line 3550 "engine.c"
			}
		}
	}
#line 65 "engine.vala"
	_tmp7_ = ibus_prop_list_new ();
#line 65 "engine.vala"
	g_object_ref_sink (_tmp7_);
#line 65 "engine.vala"
	_g_object_unref0 (self->priv->prop_list);
#line 65 "engine.vala"
	self->priv->prop_list = _tmp7_;
#line 66 "engine.vala"
	_tmp8_ = ibus_prop_list_new ();
#line 66 "engine.vala"
	g_object_ref_sink (_tmp8_);
#line 66 "engine.vala"
	props = _tmp8_;
#line 69 "engine.vala"
	_tmp9_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_HIRAGANA, "InputMode.Hiragana", _ ("Hiragana"), "あ");
#line 69 "engine.vala"
	_g_object_unref0 (prop);
#line 69 "engine.vala"
	prop = _tmp9_;
#line 73 "engine.vala"
	_tmp10_ = props;
#line 73 "engine.vala"
	_tmp11_ = prop;
#line 73 "engine.vala"
	ibus_prop_list_append (_tmp10_, _tmp11_);
#line 75 "engine.vala"
	_tmp12_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_KATAKANA, "InputMode.Katakana", _ ("Katakana"), "ア");
#line 75 "engine.vala"
	_g_object_unref0 (prop);
#line 75 "engine.vala"
	prop = _tmp12_;
#line 79 "engine.vala"
	_tmp13_ = props;
#line 79 "engine.vala"
	_tmp14_ = prop;
#line 79 "engine.vala"
	ibus_prop_list_append (_tmp13_, _tmp14_);
#line 81 "engine.vala"
	_tmp15_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_HANKAKU_KATAKANA, "InputMode.HankakuKatakana", _ ("Halfwidth Katakana"), "_ｱ");
#line 81 "engine.vala"
	_g_object_unref0 (prop);
#line 81 "engine.vala"
	prop = _tmp15_;
#line 85 "engine.vala"
	_tmp16_ = props;
#line 85 "engine.vala"
	_tmp17_ = prop;
#line 85 "engine.vala"
	ibus_prop_list_append (_tmp16_, _tmp17_);
#line 87 "engine.vala"
	_tmp18_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_LATIN, "InputMode.Latin", _ ("Latin"), "_A");
#line 87 "engine.vala"
	_g_object_unref0 (prop);
#line 87 "engine.vala"
	prop = _tmp18_;
#line 91 "engine.vala"
	_tmp19_ = props;
#line 91 "engine.vala"
	_tmp20_ = prop;
#line 91 "engine.vala"
	ibus_prop_list_append (_tmp19_, _tmp20_);
#line 93 "engine.vala"
	_tmp21_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_WIDE_LATIN, "InputMode.WideLatin", _ ("Wide Latin"), "Ａ");
#line 93 "engine.vala"
	_g_object_unref0 (prop);
#line 93 "engine.vala"
	prop = _tmp21_;
#line 97 "engine.vala"
	_tmp22_ = props;
#line 97 "engine.vala"
	_tmp23_ = prop;
#line 97 "engine.vala"
	ibus_prop_list_append (_tmp22_, _tmp23_);
#line 99 "engine.vala"
	_tmp24_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_DIRECT, "InputMode.Direct", _ ("Direct Input"), "_A");
#line 99 "engine.vala"
	_g_object_unref0 (prop);
#line 99 "engine.vala"
	prop = _tmp24_;
#line 103 "engine.vala"
	_tmp25_ = props;
#line 103 "engine.vala"
	_tmp26_ = prop;
#line 103 "engine.vala"
	ibus_prop_list_append (_tmp25_, _tmp26_);
#line 105 "engine.vala"
	_tmp27_ = ibus_text_new_from_string ("あ");
#line 105 "engine.vala"
	g_object_ref_sink (_tmp27_);
#line 105 "engine.vala"
	_tmp28_ = _tmp27_;
#line 105 "engine.vala"
	_tmp29_ = ibus_text_new_from_string (_ ("Switch input mode"));
#line 105 "engine.vala"
	g_object_ref_sink (_tmp29_);
#line 105 "engine.vala"
	_tmp30_ = _tmp29_;
#line 105 "engine.vala"
	_tmp31_ = props;
#line 105 "engine.vala"
	_tmp32_ = ibus_property_new ("InputMode", PROP_TYPE_MENU, _tmp28_, NULL, _tmp30_, TRUE, TRUE, PROP_STATE_UNCHECKED, _tmp31_);
#line 105 "engine.vala"
	g_object_ref_sink (_tmp32_);
#line 105 "engine.vala"
	_g_object_unref0 (prop);
#line 105 "engine.vala"
	prop = _tmp32_;
#line 105 "engine.vala"
	_g_object_unref0 (_tmp30_);
#line 105 "engine.vala"
	_g_object_unref0 (_tmp28_);
#line 115 "engine.vala"
	_tmp33_ = self->priv->prop_list;
#line 115 "engine.vala"
	_tmp34_ = prop;
#line 115 "engine.vala"
	ibus_prop_list_append (_tmp33_, _tmp34_);
#line 116 "engine.vala"
	_tmp35_ = prop;
#line 116 "engine.vala"
	_tmp36_ = _g_object_ref0 (_tmp35_);
#line 116 "engine.vala"
	_g_object_unref0 (self->priv->input_mode_prop);
#line 116 "engine.vala"
	self->priv->input_mode_prop = _tmp36_;
#line 118 "engine.vala"
	_tmp37_ = ibus_text_new_from_string (_ ("Preferences"));
#line 118 "engine.vala"
	g_object_ref_sink (_tmp37_);
#line 118 "engine.vala"
	_tmp38_ = _tmp37_;
#line 118 "engine.vala"
	_tmp39_ = ibus_text_new_from_string (_ ("Configure Kana Kanji Conversion"));
#line 118 "engine.vala"
	g_object_ref_sink (_tmp39_);
#line 118 "engine.vala"
	_tmp40_ = _tmp39_;
#line 118 "engine.vala"
	_tmp41_ = ibus_property_new ("setup", PROP_TYPE_NORMAL, _tmp38_, "gtk-preferences", _tmp40_, TRUE, TRUE, PROP_STATE_UNCHECKED, NULL);
#line 118 "engine.vala"
	g_object_ref_sink (_tmp41_);
#line 118 "engine.vala"
	_g_object_unref0 (prop);
#line 118 "engine.vala"
	prop = _tmp41_;
#line 118 "engine.vala"
	_g_object_unref0 (_tmp40_);
#line 118 "engine.vala"
	_g_object_unref0 (_tmp38_);
#line 128 "engine.vala"
	_tmp42_ = self->priv->prop_list;
#line 128 "engine.vala"
	_tmp43_ = prop;
#line 128 "engine.vala"
	ibus_prop_list_append (_tmp42_, _tmp43_);
#line 131 "engine.vala"
	_tmp44_ = kkc_engine_language_model;
#line 131 "engine.vala"
	_tmp45_ = kkc_context_new (_tmp44_);
#line 131 "engine.vala"
	_g_object_unref0 (self->priv->context);
#line 131 "engine.vala"
	self->priv->context = _tmp45_;
#line 3718 "engine.c"
	{
		GeeArrayList* _dictionary_list = NULL;
		GeeArrayList* _tmp46_;
		gint _dictionary_size = 0;
		GeeArrayList* _tmp47_;
		gint _tmp48_;
		gint _tmp49_;
		gint _dictionary_index = 0;
#line 133 "engine.vala"
		_tmp46_ = kkc_engine_dictionaries;
#line 133 "engine.vala"
		_dictionary_list = _tmp46_;
#line 133 "engine.vala"
		_tmp47_ = _dictionary_list;
#line 133 "engine.vala"
		_tmp48_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp47_);
#line 133 "engine.vala"
		_tmp49_ = _tmp48_;
#line 133 "engine.vala"
		_dictionary_size = _tmp49_;
#line 133 "engine.vala"
		_dictionary_index = -1;
#line 133 "engine.vala"
		while (TRUE) {
#line 3743 "engine.c"
			gint _tmp50_;
			gint _tmp51_;
			KkcDictionary* dictionary = NULL;
			GeeArrayList* _tmp52_;
			gpointer _tmp53_;
			KkcContext* _tmp54_;
			KkcDictionaryList* _tmp55_;
			KkcDictionaryList* _tmp56_;
			KkcDictionary* _tmp57_;
#line 133 "engine.vala"
			_dictionary_index = _dictionary_index + 1;
#line 133 "engine.vala"
			_tmp50_ = _dictionary_index;
#line 133 "engine.vala"
			_tmp51_ = _dictionary_size;
#line 133 "engine.vala"
			if (!(_tmp50_ < _tmp51_)) {
#line 133 "engine.vala"
				break;
#line 3763 "engine.c"
			}
#line 133 "engine.vala"
			_tmp52_ = _dictionary_list;
#line 133 "engine.vala"
			_tmp53_ = gee_abstract_list_get ((GeeAbstractList*) _tmp52_, _dictionary_index);
#line 133 "engine.vala"
			dictionary = (KkcDictionary*) _tmp53_;
#line 134 "engine.vala"
			_tmp54_ = self->priv->context;
#line 134 "engine.vala"
			_tmp55_ = kkc_context_get_dictionaries (_tmp54_);
#line 134 "engine.vala"
			_tmp56_ = _tmp55_;
#line 134 "engine.vala"
			_tmp57_ = dictionary;
#line 134 "engine.vala"
			kkc_dictionary_list_add (_tmp56_, _tmp57_);
#line 133 "engine.vala"
			_g_object_unref0 (dictionary);
#line 3783 "engine.c"
		}
	}
#line 137 "engine.vala"
	kkc_engine_apply_preferences (self);
#line 138 "engine.vala"
	_tmp58_ = kkc_engine_preferences;
#line 138 "engine.vala"
	g_signal_connect_object (_tmp58_, "value-changed", (GCallback) __kkc_engine___lambda7__preferences_value_changed, self, 0);
#line 149 "engine.vala"
	_tmp59_ = self->priv->context;
#line 149 "engine.vala"
	g_signal_connect_object ((GObject*) _tmp59_, "notify::input", (GCallback) __kkc_engine___lambda8__g_object_notify, self, 0);
#line 152 "engine.vala"
	_tmp60_ = self->priv->context;
#line 152 "engine.vala"
	g_signal_connect_object ((GObject*) _tmp60_, "notify::input-mode", (GCallback) __kkc_engine___lambda9__g_object_notify, self, 0);
#line 155 "engine.vala"
	_tmp61_ = self->priv->context;
#line 155 "engine.vala"
	_tmp62_ = kkc_context_get_candidates (_tmp61_);
#line 155 "engine.vala"
	_tmp63_ = _tmp62_;
#line 155 "engine.vala"
	g_signal_connect_object (_tmp63_, "populated", (GCallback) __kkc_engine___lambda10__kkc_candidate_list_populated, self, 0);
#line 158 "engine.vala"
	_tmp64_ = self->priv->context;
#line 158 "engine.vala"
	_tmp65_ = kkc_context_get_candidates (_tmp64_);
#line 158 "engine.vala"
	_tmp66_ = _tmp65_;
#line 158 "engine.vala"
	g_signal_connect_object ((GObject*) _tmp66_, "notify::cursor-pos", (GCallback) __kkc_engine___lambda11__g_object_notify, self, 0);
#line 161 "engine.vala"
	_tmp67_ = self->priv->context;
#line 161 "engine.vala"
	_tmp68_ = kkc_context_get_candidates (_tmp67_);
#line 161 "engine.vala"
	_tmp69_ = _tmp68_;
#line 161 "engine.vala"
	g_signal_connect_object (_tmp69_, "selected", (GCallback) __kkc_engine___lambda12__kkc_candidate_list_selected, self, 0);
#line 170 "engine.vala"
	_tmp70_ = gtk_clipboard_get (GDK_SELECTION_PRIMARY);
#line 170 "engine.vala"
	_tmp71_ = _g_object_ref0 (_tmp70_);
#line 170 "engine.vala"
	_g_object_unref0 (self->priv->clipboard);
#line 170 "engine.vala"
	self->priv->clipboard = _tmp71_;
#line 171 "engine.vala"
	_tmp72_ = self->priv->context;
#line 171 "engine.vala"
	g_signal_connect_object (_tmp72_, "request-selection-text", (GCallback) __kkc_engine___lambda13__kkc_context_request_selection_text, self, 0);
#line 176 "engine.vala"
	kkc_engine_update_candidates (self);
#line 177 "engine.vala"
	kkc_engine_update_input_mode (self);
#line 55 "engine.vala"
	_g_object_unref0 (prop);
#line 55 "engine.vala"
	_g_object_unref0 (props);
#line 55 "engine.vala"
	return obj;
#line 3846 "engine.c"
}

static void
kkc_engine_class_init (KkcEngineClass * klass,
                       gpointer klass_data)
{
#line 22 "engine.vala"
	kkc_engine_parent_class = g_type_class_peek_parent (klass);
#line 22 "engine.vala"
	g_type_class_adjust_private_offset (klass, &KkcEngine_private_offset);
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->process_key_event = (gboolean (*) (IBusEngine*, guint, guint, guint)) kkc_engine_real_process_key_event;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->enable = (void (*) (IBusEngine*)) kkc_engine_real_enable;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->disable = (void (*) (IBusEngine*)) kkc_engine_real_disable;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->reset = (void (*) (IBusEngine*)) kkc_engine_real_reset;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->focus_in = (void (*) (IBusEngine*)) kkc_engine_real_focus_in;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->focus_out = (void (*) (IBusEngine*)) kkc_engine_real_focus_out;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->property_activate = (void (*) (IBusEngine*, const gchar*, guint)) kkc_engine_real_property_activate;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->candidate_clicked = (void (*) (IBusEngine*, guint, guint, guint)) kkc_engine_real_candidate_clicked;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->cursor_up = (void (*) (IBusEngine*)) kkc_engine_real_cursor_up;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->cursor_down = (void (*) (IBusEngine*)) kkc_engine_real_cursor_down;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->page_up = (void (*) (IBusEngine*)) kkc_engine_real_page_up;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->page_down = (void (*) (IBusEngine*)) kkc_engine_real_page_down;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->set_content_type = (void (*) (IBusEngine*, guint, guint)) kkc_engine_real_set_content_type;
#line 22 "engine.vala"
	G_OBJECT_CLASS (klass)->constructor = kkc_engine_constructor;
#line 22 "engine.vala"
	G_OBJECT_CLASS (klass)->finalize = kkc_engine_finalize;
#line 3887 "engine.c"
}

static void
kkc_engine_instance_init (KkcEngine * self,
                          gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
#line 22 "engine.vala"
	self->priv = kkc_engine_get_instance_private (self);
#line 44 "engine.vala"
	self->priv->properties_registered = FALSE;
#line 46 "engine.vala"
	_tmp0_ = gee_hash_map_new (KKC_TYPE_INPUT_MODE, NULL, NULL, IBUS_TYPE_PROPERTY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 46 "engine.vala"
	self->priv->input_mode_props = (GeeMap*) _tmp0_;
#line 48 "engine.vala"
	_tmp1_ = gee_hash_map_new (KKC_TYPE_INPUT_MODE, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 48 "engine.vala"
	self->priv->input_mode_symbols = (GeeMap*) _tmp1_;
#line 50 "engine.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, KKC_TYPE_INPUT_MODE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 50 "engine.vala"
	self->priv->name_input_modes = (GeeMap*) _tmp2_;
#line 536 "engine.vala"
	self->priv->save_dictionaries_timeout_id = (guint) 0;
#line 3915 "engine.c"
}

static void
kkc_engine_finalize (GObject * obj)
{
	KkcEngine * self;
#line 22 "engine.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KKC_ENGINE, KkcEngine);
#line 34 "engine.vala"
	_g_object_unref0 (self->priv->context);
#line 35 "engine.vala"
	_g_object_unref0 (self->priv->lookup_table);
#line 41 "engine.vala"
	_g_object_unref0 (self->priv->keymap);
#line 42 "engine.vala"
	_g_object_unref0 (self->priv->input_mode_prop);
#line 43 "engine.vala"
	_g_object_unref0 (self->priv->prop_list);
#line 46 "engine.vala"
	_g_object_unref0 (self->priv->input_mode_props);
#line 48 "engine.vala"
	_g_object_unref0 (self->priv->input_mode_symbols);
#line 50 "engine.vala"
	_g_object_unref0 (self->priv->name_input_modes);
#line 53 "engine.vala"
	_g_object_unref0 (self->priv->clipboard);
#line 22 "engine.vala"
	G_OBJECT_CLASS (kkc_engine_parent_class)->finalize (obj);
#line 3944 "engine.c"
}

static GType
kkc_engine_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KkcEngineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_engine_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcEngine), 0, (GInstanceInitFunc) kkc_engine_instance_init, NULL };
	GType kkc_engine_type_id;
	kkc_engine_type_id = g_type_register_static (IBUS_TYPE_ENGINE, "KkcEngine", &g_define_type_info, 0);
	KkcEngine_private_offset = g_type_add_instance_private (kkc_engine_type_id, sizeof (KkcEnginePrivate));
	return kkc_engine_type_id;
}

GType
kkc_engine_get_type (void)
{
	static volatile gsize kkc_engine_type_id__once = 0;
	if (g_once_init_enter (&kkc_engine_type_id__once)) {
		GType kkc_engine_type_id;
		kkc_engine_type_id = kkc_engine_get_type_once ();
		g_once_init_leave (&kkc_engine_type_id__once, kkc_engine_type_id);
	}
	return kkc_engine_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

